// AecMfc32TimeCodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AecMfc32TimeCode.h"
#include "AecMfc32TimeCodeDlg.h"
#include "Aec_Variables.h"
#include "AecOSDdlg.h"
#include "AecSony422.h"
#include "AecSio.h"
#include "AecL21.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAecMfc32TimeCodeDlg dialog

CAecMfc32TimeCodeDlg::CAecMfc32TimeCodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAecMfc32TimeCodeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAecMfc32TimeCodeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

//	if (!buttonUP.LoadBitmaps(IDB_BITMAP_UPA, IDB_BITMAP_UPB, IDB_BITMAP_UPC, 0))
//		MessageBox("no", "BitMap",MB_OK);


	pDlgOSD = NULL;
	pDlgSony422 = NULL;
	pDlgSIO = NULL;
	pDlgL21 = NULL;

}


//===============================================================================
void CAecMfc32TimeCodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAecMfc32TimeCodeDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAecMfc32TimeCodeDlg, CDialog)
	//{{AFX_MSG_MAP(CAecMfc32TimeCodeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_R1_GO, OnButtonR1Go)
	ON_BN_CLICKED(IDC_BUTTON_R4_GO, OnButtonR4Go)
	ON_BN_CLICKED(IDC_BUTTON_W1_GO, OnButtonW1Go)
	ON_BN_CLICKED(IDC_BUTTON_W4_GO, OnButtonW4Go)
	ON_BN_CLICKED(IDC_BUTTON_SC_GO, OnButtonScGo)
	ON_BN_CLICKED(IDC_BUTTON_VID_COUNT_ZERO, OnButtonVidCountZero)
	ON_BN_CLICKED(IDC_BUTTON_PUT_FPS, OnButtonPutFps)
	ON_BN_CLICKED(IDC_BUTTON_JAMGENALL, OnButtonJamgenall)
	ON_BN_CLICKED(IDC_BUTTON_JAMGENTB, OnButtonJamgentb)
	ON_BN_CLICKED(IDC_BUTTON_JAMGENUB, OnButtonJamgenub)
	ON_BN_CLICKED(IDC_BUTTON_JAMGENEB, OnButtonJamgeneb)
	ON_BN_CLICKED(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, OnCheckGenRununchangedstop)
	ON_BN_CLICKED(IDC_CHECK_GEN_PAUSE_GO, OnCheckGenPauseGo)
	ON_BN_CLICKED(IDC_CHECK_GEN_DIS_ENABLE, OnCheckGenDisEnable)
	ON_BN_CLICKED(IDC_BUTTON_FORCE_GEN_UPDATE, OnButtonForceGenUpdate)
	ON_BN_CLICKED(IDC_BUTTON_FORCE_READ_UPDATE, OnButtonForceReadUpdate)
	ON_BN_CLICKED(IDC_RADIO_SYNC_VID, OnRadioSyncVid)
	ON_BN_CLICKED(IDC_RADIO_SYNC_LTC, OnRadioSyncLtc)
	ON_BN_CLICKED(IDC_RADIO_GEN_FREERUN, OnRadioGenFreerun)
	ON_BN_CLICKED(IDC_CHECK_GENDF, OnCheckGendf)
	ON_BN_CLICKED(IDC_CHECK_GENDOWN, OnCheckGendown)
	ON_BN_CLICKED(IDC_CHECK_JAM_READER, OnCheckJamReader)
	ON_BN_CLICKED(IDC_CHECK_NOJAMUB, OnCheckNojamub)
	ON_BN_CLICKED(IDC_BUTTON_CMPSTART, OnButtonCmpstart)
	ON_BN_CLICKED(IDC_RADIO_CMPREAD, OnRadioCmpread)
	ON_BN_CLICKED(IDC_RADIO_CMPGEN, OnRadioCmpgen)
	ON_BN_CLICKED(IDC_BUTTON_NEXT, OnButtonNext)
	ON_BN_CLICKED(IDC_BUTTON_PREV, OnButtonPrev)
	ON_BN_CLICKED(IDCLOSE, OnClose)
	ON_BN_CLICKED(IDC_CHECK_GEN_LTC, OnCheckGenLtc)
	ON_BN_CLICKED(IDC_CHECK_GEN_VITC, OnCheckGenVitc)
	ON_BN_CLICKED(IDC_CHECK_READ_VITC, OnCheckReadVitc)
	ON_BN_CLICKED(IDC_CHECK_READ_LTC, OnCheckReadLtc)
	ON_BN_CLICKED(IDC_CHECK_SONY422_DLG, OnCheckSony422Dlg)
	ON_BN_CLICKED(IDC_CHECK_L21_DLGBOX, OnCheckL21Dlgbox)
	ON_BN_CLICKED(IDC_CHECK_OSD_DLGBOX, OnCheckOsdDlgbox)
	ON_BN_CLICKED(AEC_CHECK_INT_L21ON, OnCheckIntL21on)
	ON_BN_CLICKED(AEC_CHECK_INT_CMPON, OnCheckIntCmpon)
	ON_BN_CLICKED(AEC_CHECK_INT_RXON, OnCheckIntRxon)
	ON_BN_CLICKED(AEC_CHECK_INT_TXON, OnCheckIntTxon)
	ON_BN_CLICKED(AEC_CHECK_INT_GENON, OnCheckIntGenon)
	ON_BN_CLICKED(AEC_CHECK_INT_VIDON, OnCheckIntVidon)
	ON_BN_CLICKED(AEC_CHECK_INT_RDRON, OnCheckIntRdron)
	ON_BN_CLICKED(IDC_CHECK_ISR_ONLY, OnCheckIsrOnly)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_GENCF, OnCheckGencf)
	ON_BN_CLICKED(IDC_RADIO_SYNC_LOGIC, OnRadioSyncLogic)
	ON_BN_CLICKED(IDC_BUTTON_DO_NTSC, OnButtonDoNtsc)
	ON_BN_CLICKED(IDC_BUTTON_DO_PAL, OnButtonDoPal)
	ON_BN_CLICKED(IDC_BUTTON_DO_FILM, OnButtonDoFilm)
	ON_BN_CLICKED(IDC_CHECK_SIO_GENERIC_DLG, OnCheckSioGenericDlg)
	ON_BN_CLICKED(IDC_SIMULATE_TIMER, OnSimulateTimer)
	ON_WM_DESTROY()
	ON_MESSAGE(WM_AEC_SONY422, OnWmAecSony422)
	ON_MESSAGE(WM_AEC_SIO, OnWmAecSIO)
	ON_MESSAGE(WM_AEC_L21, OnWmAecL21)
	ON_MESSAGE(WM_AEC_OSD, OnWmOSD)
	ON_WM_CANCELMODE()
	ON_BN_CLICKED(IDC_CHECK_POLL_FAST, OnCheckPollFast)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//	ON_MESSAGE(WM_AEC_REW, OnWmAecREW)

/////////////////////////////////////////////////////////////////////////////
// CAecMfc32TimeCodeDlg message handlers

BOOL CAecMfc32TimeCodeDlg::OnInitDialog()
{
	static char title_id[60];
	char AddrStr[10];
	cmpRtb = 0xFFFFFFFF;
	cmpRub = 0xFF0FFFFF;
	cmpGtb = 0xFFFFFFFF;
	cmpGub = 0xFF0FFFFF;
	cmpReb = 0xFF;
	cmpGeb = 0xFF;
	b_ISRtranstion = false;
	//cmp0C = 0x00;
	//cmp0D = 0x00;



	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//do PC-TC stuff and then start the timer

	//new---> here to end of func.

	boardNum = tc1.GetCountRegistered();	//
	if (tc1.GetCountFound() != 0)
	{
		iSelected = 0;	//the CAec class sets this program to use the FIRST board
						//that is FOUND by search (0 based index)
		strcpy(title_str, title_strBase);
		strcat(title_str, tc1.GetStrId(title_id));
		strcat(title_str, " (Address ");
		strcat(title_str, sh1.WStr(tc1.BrdAddr(), AddrStr));
		strcat(title_str, ")");
	}
	else 	strcat(title_str, "(no board found)");

    lpPassToAECDLLrev = (LPSTR) &rev;
	aecint = tc1.GetDll_info(lpPassToAECDLLrev);
	//wsprintf (dllinfo,"AEC_NTTC.DLL Rev. %c%c - ", rev[0], rev[1]);
	wsprintf (dllinfo," AEC_NTTC.DLL '%c%c'", rev[0], rev[1]);
//	if (tc1.GetCountFound() != 0)
//	{
//		strcat(dllinfo, tc1.GetStrId(title_id));
//		strcat(dllinfo, " (Address ");
//		strcat(dllinfo, sh1.WStr(tc1.BrdAddr(), AddrStr));
//		strcat(dllinfo, ")");
//	}
//	else  	strcat(dllinfo, "(no board found)");

	//strcat(dllinfo, title_str);
	strcat(title_str, dllinfo);
	SetDlgItemText(IDC_EDIT_BRD_INFO, title_str);
	//SetDlgItemText(IDC_EDIT_BRD_INFO, dllinfo);
	//Put code here to fill in "1of2"....

	//if (tc1.BrdType() == 4)	//PCI
	//hMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_PCI));




		// **NEW**
		// This is important!! Make this program has the Priority that you
		// want it to have. I have decided that I want this program to run
		// as close as possible to REAL_TIME (highest Priority)
		// or interrupts will not be processed quickly enough
	SetPriorityClass( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );

	//11-25-02 ADD NEXT BACK
	tc1.OrIntEnables(0x3F);	//set all bits of int enables - bits 0-6	
	//11-25-02 CLR NEXT 
	//tc1.AndIntEnables(0x00);	//clear all enables

	OnButtonVidCountZero();
	InitStatus_N_Signals();

	//11-25-02 ADD NEXT BACK
	InitGenStatusAll();

	m_PollFast = true;
	m_Dlg_Timer = SetTimer(1, 300, 0);
	//KillTimer(m_Dlg_Timer);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAecMfc32TimeCodeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if ((nID & 0xFFF0) == SC_CLOSE)	//SC_SCREENSAVE too?
	{
		OnCancel();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAecMfc32TimeCodeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAecMfc32TimeCodeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAecMfc32TimeCodeDlg::OnButtonR1Go() 
{
	// TODO: Add code to read one byte and write back to
	//       edit box.
	if (GetDlgItemText(IDC_EDIT_R1_ADDR,sOffset,4))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0x400)
		{
			BRone = tc1.Read1(wOffset);
			//DISPLAY DATA
			sh1.BStr(BRone, hhmmssff);
			SetDlgItemText(IDC_EDIT_R1_OUTPUT, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_R1_OUTPUT, "Err");
	}
	else SetDlgItemText(IDC_EDIT_R1_OUTPUT, "Err"); 
					
}

void CAecMfc32TimeCodeDlg::OnButtonR4Go() 
{
	// TODO: Add code to read four bytes and write back to
	//       edit box.
	if (GetDlgItemText(IDC_EDIT_R4_ADDR,sOffset,4))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0x3FC)
		{
			dRfour = tc1.Read4(wOffset);
			//DISPLAY DATA
			sh1.DWStrTm(dRfour, hhmmssff);
			SetDlgItemText(IDC_EDIT_R4_OUTPUT, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_R4_OUTPUT, "Addr Err");
	}
	else SetDlgItemText(IDC_EDIT_R4_OUTPUT, "Error"); 

	
}

void CAecMfc32TimeCodeDlg::OnButtonW1Go() 
{
	// TODO: Add code to write one byte to TC device
	if ((GetDlgItemText(IDC_EDIT_W1_ADDR,sOffset,4)) &&
		(GetDlgItemText(IDC_EDIT_W1_INPUT, sBuffer, 3)))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0x400)	//TODO: make address ranges ok for PCI too. (<FCh)
		{
			BWone = (BYTE)sh1.ToHex(sBuffer);
			bWrite = tc1.Write1(BWone, wOffset);
			//DISPLAY DATA/status
			sh1.BStr(BWone, hhmmssff);
			SetDlgItemText(IDC_EDIT_W1_INPUT, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_W1_ADDR, "AEr");
	}
	else SetDlgItemText(IDC_EDIT_W1_ADDR, "Err");
}

void CAecMfc32TimeCodeDlg::OnButtonW4Go() 
{
	// TODO: Add code to write four bytes to TC device
	if ((GetDlgItemText(IDC_EDIT_W4_ADDR,sOffset,4)) &&
		(GetDlgItemText(IDC_EDIT_W4_INPUT, sBuffer, 12)))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0x3FD)	//TODO: make address ranges ok for PCI too. (<FDh)
		{
			dWfour = (DWORD)sh1.ToHex(sBuffer);
			bWrite = tc1.Write4(dWfour, wOffset);
			sh1.DWStrTm(dWfour, hhmmssff);
			SetDlgItemText(IDC_EDIT_W4_INPUT, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_W4_ADDR, "AEr");
	}
	else SetDlgItemText(IDC_EDIT_W4_INPUT, "Error");  	
}

void CAecMfc32TimeCodeDlg::OnButtonScGo() 
{
	// TODO: Add code to send command to TC device
	if (GetDlgItemText(IDC_EDIT_SC_INPUT, sBuffer, 3))
	{
		BWone = (BYTE)sh1.ToHex(sBuffer);
		BRone = tc1.SendCom(BWone);
			//DISPLAY DATA


		//Code here to put '??' when the returned ACK/NAK code
		// is NOT an allowed value for PROPER operation.
		if (BRone != BWone) //could have an error
		{
			//see if command is 2x and return value is 2x
			if ((BRone & 0x20) == (BWone  & 0x20))
				sh1.BStr(BRone, hhmmssff);
			else
			{
				sh1.BStr(BRone, hhmmssff);
				hhmmssff[2] ='?';
				hhmmssff[3] = 0;
			}
		}
		else
			sh1.BStr(BRone, hhmmssff);
		
		SetDlgItemText(IDC_EDIT_SC_OUTPUT, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_SC_OUTPUT, "???"); 
	InitGenStatus();
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonDoNtsc() //IDC_BUTTON_DO_NTSC
{
	// Get the current state settings and then send command 0x03
	//and then restore to the state upon return;
	BYTE temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	
	cmd = (cmp0D & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)
	if ((cmd & 0x0C) != 0)	//If the board had generator active
	{	
		if (tc1.GensLtc() || tc1.GensVitc())
		{

			//Gen output operating mode status (4A/45h)========================
			if (tc1.BrdType() == 4)	//PCI
			{
				temp = tc1.Read1(0x004A);	//pci
				if (temp & 0x01)
					frz = 1;
				else frz = 0;
				if (temp & 0x02)
					able = 1;
				else able = 0;
			}
			else 
			{
				temp = tc1.Read1(0x0045);   //isa
				if (temp & 0x40)
					frz = 0;		//UNFrozen = 0
				else frz = 1;
				if (temp & 0x80)
					able = 0;		//DISabled =0
				else able = 1;
			}
		}
	}
	
	tc1.Smpte();	//put in the desired mode.
	Sleep(1);	//temp10_02
	tc1.SendCom(cmd);
	Sleep(1);	//temp10_02
	if ((cmd & 0x0C) != 0)	//If the board had generator active
	{
		Sleep(1);	//temp10_02
		if (frz && able)	//gen is active normal
			tc1.SendCom(0x48);	//start again

		else if (frz)	//NOT frozen 
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4E); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
									//have a "status" that tells if board gen has
									//been running OR NOT. Just make it run (safer)
				//b = tc1.Read1(0x0045);
				//b = b & 0xBF;	//clr bit6=0
				//tc1.Write1(b, 0x0045);	
			}	
		}
		else if (able)	//ENABLED
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4B); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again
				//b = tc1.Read1(0x0045);
				//b = b & 0x7F;	//clr bit7=0
				//tc1.Write1(b, 0x0045);	
			}	
		}	
	}	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonDoPal()	//IDC_BUTTON_DO_PAL
{
	// Get the current state settings and then send command 0x04
	//and then restore to the state upon return;	
	BYTE temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	
	cmd = (cmp0D & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)
	if ((cmd & 0x0C) != 0)	//If the board had generator active
	{	
		if (tc1.GensLtc() || tc1.GensVitc())
		{

			//Gen output operating mode status (4A/45h)========================
			if (tc1.BrdType() == 4)	//PCI
			{
				temp = tc1.Read1(0x004A);	//pci
				if (temp & 0x01)
					frz = 1;
				else frz = 0;
				if (temp & 0x02)
					able = 1;
				else able = 0;
			}
			else 
			{
				temp = tc1.Read1(0x0045);   //isa
				if (temp & 0x40)
					frz = 0;		//UNFrozen = 0
				else frz = 1;
				if (temp & 0x80)
					able = 0;		//DISabled =0
				else able = 1;
			}
		}
	}
	
	tc1.Ebu();	//put in the desired mode.
	tc1.SendCom(cmd);
	if ((cmd & 0x0C) != 0)	//If the board had generator active
	{
		if (frz && able)	//gen is active normal
			tc1.SendCom(0x48);	//start again

		else if (frz)	//NOT frozen 
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4E); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
									//have a "status" that tells if board gen has
									//been running OR NOT. Just make it run (safer)
				//b = tc1.Read1(0x0045);
				//b = b & 0xBF;	//clr bit6=0
				//tc1.Write1(b, 0x0045);	
			}	
		}
		else if (able)	//ENABLED
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4B); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again
				//b = tc1.Read1(0x0045);
				//b = b & 0x7F;	//clr bit7=0
				//tc1.Write1(b, 0x0045);	
			}	
		}	
	}
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonDoFilm()	//IDC_BUTTON_DO_FILM //filmAble
{
	// Get the current state settings and then send command 0x05
	//and then restore to the state upon return;
	BYTE temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	
	cmd = (cmp0D & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)
	if ((cmd & 0x0C) != 0)	//If the board had generator active
	{	
		if (tc1.GensLtc() || tc1.GensVitc())
		{

			//Gen output operating mode status (4A/45h)========================
			if (tc1.BrdType() == 4)	//PCI
			{
				temp = tc1.Read1(0x004A);	//pci
				if (temp & 0x01)
					frz = 1;
				else frz = 0;
				if (temp & 0x02)
					able = 1;
				else able = 0;
			}
			else 
			{
				temp = tc1.Read1(0x0045);   //isa
				if (temp & 0x40)
					frz = 0;		//UNFrozen = 0
				else frz = 1;
				if (temp & 0x80)
					able = 0;		//DISabled =0
				else able = 1;
			}
		}
	}
	
	tc1.FilmHD();	//put in the desired mode.
	tc1.SendCom(cmd);
	if ((cmd & 0x0C) != 0)	//If the board had generator active
	{
		if (frz && able)	//gen is active normal
			tc1.SendCom(0x48);	//start again

		else if (frz)	//NOT frozen 
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4E); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
									//have a "status" that tells if board gen has
									//been running OR NOT. Just make it run (safer)
				//b = tc1.Read1(0x0045);
				//b = b & 0xBF;	//clr bit6=0
				//tc1.Write1(b, 0x0045);	
			}	
		}
		else if (able)	//ENABLED
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4B); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again
				//b = tc1.Read1(0x0045);
				//b = b & 0x7F;	//clr bit7=0
				//tc1.Write1(b, 0x0045);	
			}	
		}	
	}
}
//=======================================================================

// Reset the video field counter and video timer
void CAecMfc32TimeCodeDlg::OnButtonVidCountZero() 
{

	if ( (tc1.GensLtc()) || (tc1.GensVitc()) || (tc1.ReadsVitc()) || (tc1.HasL21()) )
	{
		tc1.vidCounter = 0;
		SetDlgItemText(IDC_EDIT_VID_FPS, "0");
		SetDlgItemText(IDC_EDIT_VID_COUNT, "0");
		tmrVid.Zero();
	}
	else 
	{
		SetDlgItemText(IDC_EDIT_VID_FPS, "N/A");
		SetDlgItemText(IDC_EDIT_VID_COUNT, "N/A");
	}
	
/*					switch(LOWORD(lParam)) {
						case 1:
							//iFieldsTotal++;
							iFieldsTotal = tc1.vidCounter;

							if (tmrVIDup.msT() > 150)   //only update so often at max
							{
								wsprintf (cBuff,"v%d", iFieldsTotal);
								SetDlgItemText(hwndDlg, AEC_VID_FRAMES, cBuff); 
								tmrVIDup.Zero();
							}
*/
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonPutFps() 
{
	int i, j, k, m, n;
	char str[10];
	// TODO: Add code to calculate the video field interrupts/second
/*
					if ( (tc1.GensLtc()) || (tc1.GensVitc()) || (tc1.ReadsVitc()))
					{
						SetDlgItemText(hwndDlg, AEC_VID_FPS, "0");
						SetDlgItemText(hwndDlg, AEC_VID_FRAMES, "0");
						iFieldsTotal = 0;
						tc1.vidCounter = 0;
						iL21Total = 0;
						iFieldsPS = 0;
						tmrVIDup.Zero();
						tmrVid.Zero();
					}
					else	// no video sync
					{
						SetDlgItemText(hwndDlg, AEC_VID_FPS, "N/A");
						SetDlgItemText(hwndDlg, AEC_VID_FRAMES, "N/A");
						tmrVIDup.Zero();
					}
					break;

*/
//-----------------------
	if ( (tc1.GensLtc()) || (tc1.GensVitc()) || (tc1.ReadsVitc() || tc1.HasL21() ) )
	{
		j = tc1.vidCounter;
		k = tmrVid.msT();
		i = ((1000 * j) / k); // + 1 is for round UP
		m = ((1000 * j) % k);
		n = ((100 * m) / k);
		//i = ((1000 * tc1.vidCounter) / (tmrVid.msT())); // + 1 is for round UP
		wsprintf (str,"%d.%2.2d",i, n);
		//wsprintf (str,"%d",i);
		SetDlgItemText(IDC_EDIT_VID_FPS, str);
	}
	else 
		SetDlgItemText(IDC_EDIT_VID_FPS, "N/A");


}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonJamgenall() //IDC_BUTTON_JAMGENALL
{
	BYTE BTemp = 0;
	// TODO: Add code to get the time and user data (+DF flag) and send command 40h
	if (GetDlgItemText(IDC_EDIT_GENTBINPUT, sBuffer, 12))
	{
		dWfour = (DWORD)sh1.ToHex(sBuffer);
		tc1.WriteGenTUE(1, dWfour, 0,0, 0,0);
		sh1.DWStrTm(dWfour, hhmmssff);
		SetDlgItemText(IDC_EDIT_GENTBINPUT, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_GENTBINPUT, "Error");  
	//======================================================
	if (GetDlgItemText(IDC_EDIT_GENUBINPUT, sBuffer, 12))
	{
		dWfour = (DWORD)sh1.ToHex(sBuffer);
		tc1.WriteGenTUE(0,0, 1, dWfour, 0,0);
		sh1.DWStrTm(dWfour, hhmmssff);
		SetDlgItemText(IDC_EDIT_GENUBINPUT, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_GENUBINPUT, "Error");  
	//======================================================
	//if (IsDlgButtonChecked(hwndDlg, AEC_INT_READ_OFF))
	if (IsDlgButtonChecked(IDC_CHECK_GENDF))
		BTemp = BTemp | 0x80;
	if (IsDlgButtonChecked(IDC_CHECK_GENCF))
		BTemp = BTemp | 0x40;	
	tc1.WriteGenTUE(0,0,0,0, 1, BTemp);

	tc1.JamTU();	//jam TimeUser (+embedded PCI)
			
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonJamgentb()	//IDC_BUTTON_JAMGENTB
{
	// TODO: Add code to get the time  and send command 41h
	if (GetDlgItemText(IDC_EDIT_GENTBINPUT, sBuffer, 12))
	{
		dWfour = (DWORD)sh1.ToHex(sBuffer);
		tc1.WriteGenTUE(1, dWfour, 0,0, 0,0);
		sh1.DWStrTm(dWfour, hhmmssff);
		SetDlgItemText(IDC_EDIT_GENTBINPUT, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_GENTBINPUT, "Error");  

	tc1.JamTB();	//jam Time
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonJamgenub()	//IDC_BUTTON_JAMGENUB
{
	// TODO: Add code to get the user and send command 42h
	if (GetDlgItemText(IDC_EDIT_GENUBINPUT, sBuffer, 12))
	{
		dWfour = (DWORD)sh1.ToHex(sBuffer);
		tc1.WriteGenTUE(0,0, 1, dWfour, 0,0);
		sh1.DWStrTm(dWfour, hhmmssff);
		SetDlgItemText(IDC_EDIT_GENUBINPUT, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_GENUBINPUT, "Error");  

	tc1.JamUB();	//jam User 	
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonJamgeneb()	//IDC_BUTTON_JAMGENEB
{
	// TODO: Add code to get the DF/CF flag  and send command 43h
	BYTE BTemp = 0;

	if (IsDlgButtonChecked(IDC_CHECK_GENDF))
		BTemp = BTemp | 0x80;
	if (IsDlgButtonChecked(IDC_CHECK_GENCF))
		BTemp = BTemp | 0x40;	
	tc1.WriteGenTUE(0,0,0,0, 1, BTemp);

	tc1.JamEB();	//jam embedded

	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGenRununchangedstop() 
{
	// TODO: Add code to get the check box status and send either
	//		command RUN (48h) or STOP (49h).
	//PCI - offset 4Ah holds bit1=Output enabled, bit0=count is running)
	//ISA - offset 45h holds bit7=Disable output, bit6=freezes count
	//Note: These have opposite bit value status?
	if (IsDlgButtonChecked(IDC_CHECK_GEN_RUNUNCHANGEDSTOP))
	{
		tc1.Start();
		SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "STOP");
		SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Time");
		CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
		SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
		CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);

	}
	else
	{
		tc1.StopGen();
		SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "START");
		SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Unfreeze Data");
		SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Enable Output");
		CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
		CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 1);
	}
	//CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
	//CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
	//SetDlgItemText(nID, LPCTSTR);
	
/*

  */
	//IDC_RADIO_SYNC_VID
	//IDC_RADIO_SYNC_LOGIC
	//IDC_RADIO_SYNC_LTC
	//IDC_RADIO_GEN_FREERUN
	//
	//
	//
	//IDC_CHECK_GENDOWN
	//IDC_CHECK_JAM_READER
	//IDC_CHECK_NOJAMUB
	//
	//
	//IDC_CHECK_GEN_PAUSE_GO
	//IDC_CHECK_GEN_DIS_ENABLE
	//
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGenPauseGo() 
{
	// code to get the check box status and send either
	//		command PAUSE (4Ah) or GO (4Bh).
	BOOL state = FALSE;
	BYTE b;
	if (IsDlgButtonChecked(IDC_CHECK_GEN_PAUSE_GO))	//FREEZE!
	{
		state = TRUE;
		SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "START");
		CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 0);
		SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Unfreeze Time");
		CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
		//SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
		//CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);

	}
	else
	{
		if (IsDlgButtonChecked(IDC_CHECK_GEN_DIS_ENABLE))
		{
			SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "START");
			CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 0);
			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Data");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
			//SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			//CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
		}
		
		else	//NOT frozen & Enabled !
		{
			SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "STOP");
			CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 1);
			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Data");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
		}

	}

	if (tc1.BrdType() == 4)	//PCI
	{
		if (state)
			tc1.SendCom(0x4D); //PCI
		else
			tc1.SendCom(0x4E); //PCI
	}
	else //ISA
	{
		b = tc1.Read1(0x0045);
		if (state)	//set 45.6
			b = b | 0x40;	//bit6=1
		else	//clr 45.6
			b = b & 0xBF;	//bit6=0
		tc1.Write1(b, 0x0045);							
	}	
}
//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGenDisEnable() 
{
	// code to get the check box status and send either
	//		command DISABLE (4Dh) or ENABLE (4Eh).
	BOOL state = FALSE;
	BYTE b;
	if (IsDlgButtonChecked(IDC_CHECK_GEN_DIS_ENABLE))	//Disabled!
	{
		state = TRUE;
		SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "START");
		CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 0);
		//SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Unfreeze Time");
		//CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
		SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Enable Output");
		CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 1);

	}
	else
	{
		if (IsDlgButtonChecked(IDC_CHECK_GEN_PAUSE_GO))
		{
			SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "START");
			CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 0);
			//SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Unfeeze Data");
			//CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
		}
		
		else	//NOT frozen & Enabled !
		{
			SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "STOP");
			CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 1);
			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Data");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
		}
	}

	if (tc1.BrdType() == 4)	//PCI
	{
		if (state)
			tc1.SendCom(0x4A); //PCI
		else
			tc1.SendCom(0x4B); //PCI
	}
	else //ISA
	{
		b = tc1.Read1(0x0045);
		if (state)	//set 45.7
			b = b | 0x80;	//bit7=1
		else		//clr 45.7
			b = b & 0x7F;	//bit7=0
		tc1.Write1(b, 0x0045);							
	}
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonForceGenUpdate() 
{
		//time
		cmpGtb = tc1.GetTimeGen();
		sh1.DWStrTm(cmpGtb, hhmmssff);
		SetDlgItemText(IDC_EDIT_TBGEN_OUTPUT, hhmmssff);
		//user
		cmpGub = tc1.GetTimeGen(); 
		sh1.DWStrTm(cmpGub, hhmmssff);
		SetDlgItemText(IDC_EDIT_UBGEN_OUTPUT, hhmmssff);
		//embedded	
		cmpGeb = (tc1.GetEBGen() & 0xF3); //mask the field (bit3/2 (NTSC/PAL)) to limit updates
		if (cmpGeb & 0x80)
			SetDlgItemText(IDC_EDIT_DFGEN_OUTPUT, "YES");
		else SetDlgItemText(IDC_EDIT_DFGEN_OUTPUT, "NO");
		if (cmpGeb & 0x40)
			SetDlgItemText(IDC_EDIT_CFGEN_OUTPUT, "YES");
		else SetDlgItemText(IDC_EDIT_CFGEN_OUTPUT, "NO");			
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonForceReadUpdate() 
{
		//time
		cmpRtb = tc1.GetTimeRead(); //tc1.tcR.t;
		sh1.DWStrTm(cmpRtb, hhmmssff);
		SetDlgItemText(IDC_EDIT_TBREADER, hhmmssff);
		//user
		cmpRub = tc1.GetUserRead(); //tc1.tcR.u;	
		sh1.DWStrTm(cmpRub, hhmmssff);
		SetDlgItemText(IDC_EDIT_UBREADER, hhmmssff);
		//embedded	//tc1.tcR.e 
		cmpReb = (tc1.GetEBRead() & 0xF3); //mask the field (bit3/2 (NTSC/PAL)) to limit updates
		if (cmpReb & 0x80)
			SetDlgItemText(IDC_EDIT_DFREADER, "YES");
		else SetDlgItemText(IDC_EDIT_DFREADER, "NO");
		if (cmpReb & 0x40)
			SetDlgItemText(IDC_EDIT_CFREADER, "YES");
		else SetDlgItemText(IDC_EDIT_CFREADER, "NO");			
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::ProcessSyncChange(BYTE b)
{
	BYTE temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	

	cmd = (cmp0D & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)
	if ((cmd & 0x0C) != 0)	//If the board has generator active
	{	
		if (tc1.GensLtc() || tc1.GensVitc())
		{

			//Gen output operating mode status (4A/45h)========================
			if (tc1.BrdType() == 4)	//PCI
			{
				temp = tc1.Read1(0x004A);	//pci
				if (temp & 0x01)
					frz = 1;
				else frz = 0;
				if (temp & 0x02)
					able = 1;
				else able = 0;
			}
			else 
			{
				temp = tc1.Read1(0x0045);   //isa
				if (temp & 0x40)
					frz = 0;		//UNFrozen = 0
				else frz = 1;
				if (temp & 0x80)
					able = 0;		//DISabled =0
				else able = 1;
			}
		}
	}
	
	tc1.SetGenSync(b);
	if ((cmd & 0x0C) != 0)	//If the board had generator active
	{
		tc1.SendCom(cmd);
		if (frz && able)	//gen is active normal
			tc1.SendCom(0x48);	//start again

		else if (frz)	//NOT frozen 
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4E); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
									//have a "status" that tells if board gen has
									//been running OR NOT. Just make it run (safer)
				//b = tc1.Read1(0x0045);
				//b = b & 0xBF;	//clr bit6=0
				//tc1.Write1(b, 0x0045);	
			}	
		}
		else if (able)	//ENABLED
		{
			if (tc1.BrdType() == 4)	//PCI
				tc1.SendCom(0x4B); //PCI
			else //ISA
			{						
				tc1.SendCom(0x48);	//start again
				//b = tc1.Read1(0x0045);
				//b = b & 0x7F;	//clr bit7=0
				//tc1.Write1(b, 0x0045);	
			}	
		}	
	}
}


//=======================================================================
//ok = CheckRadioButton(hwndDlg, IDC_XCTL, IDC_XVITC, IDC_XLTC);
//nID = GetCheckedRadioButton(nID_First, nID_Last);
void CAecMfc32TimeCodeDlg::OnRadioSyncVid()		//IDC_RADIO_SYNC_VID
{
	// Cause generator to sync to video
	BYTE b, bByte;
	b = (tc1.GetGenSync() & 0xF8);	//mask sync bits 0/1/2
	bByte = (b | BIT0);
	
	ProcessSyncChange(bByte);	//set bit0	clr 1/2
}
	//IDC_RADIO_SYNC_VID
	//IDC_RADIO_SYNC_LOGIC
	//IDC_RADIO_SYNC_LTC
	//IDC_RADIO_GEN_FREERUN

//=======================================================================
void CAecMfc32TimeCodeDlg::OnRadioSyncLogic()	//IDC_RADIO_SYNC_LOGIC
{
	// Cause generator to sync to video
	BYTE b, bByte;
	b = (tc1.GetGenSync() & 0xF8);	//mask sync bits 0/1/2
	bByte = (b | BIT1);
	
	ProcessSyncChange(bByte);	//set bit1 clr 0/2
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnRadioSyncLtc() 
{
	// Cause generator to sync to LTC Reader
	BYTE b, bByte;
	b = (tc1.GetGenSync() & 0xF8);	//mask sync bits 0/1/2
	bByte = (b | BIT2);
	
	ProcessSyncChange(bByte);	//set bit2, clr 0/1	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnRadioGenFreerun() 
{
	// Casue generator to sync to nothing (freerun)
	BYTE b, bByte;
	b = (tc1.GetGenSync() & 0xF8);	//mask sync bits 0/1/2
	bByte = b;
	
	ProcessSyncChange(bByte);	//clear bits0-2	
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGendf() 
{
	// Get the check box status and cause generator to 
	//generate DF or NDF time code depending upon status (checked = DF).
	//(disable for PAL/EBU signal mode)
	BYTE BTemp = tc1.GetEBGen();
	if (IsDlgButtonChecked(IDC_CHECK_GENDF))
		BTemp = BTemp | 0x80;	//setbit
	else BTemp = BTemp & 0x7F;	//clear bit
	
	tc1.WriteGenTUE(0,0,0,0, 1, BTemp);

	tc1.JamEB();	//jam embedded

/*

  */
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGencf() 
{
	// Get the check box status and cause generator to 
	//generate CF or time code or NOT depending upon status (checked = CF).
	//(disable for PAL/EBU signal mode)
	BYTE BTemp = tc1.GetEBGen();
	if (IsDlgButtonChecked(IDC_CHECK_GENCF))
		BTemp = BTemp | 0x40;	//setbit6
	else BTemp = BTemp & 0xBF;	//clear bit6

	tc1.WriteGenTUE(0,0,0,0, 1, BTemp);

	tc1.JamEB();	//jam embedded	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGendown() 
{
	// Cause the generator to count down (decrement)
	// or up depending upon check box status. If checked, do "down".
	//PCI set/clr 69.4 (set = down), ISA 45.4
	//
	BYTE b = tc1.GetGenModeControl();
	if (IsDlgButtonChecked(IDC_CHECK_GENDOWN))	//SET
		tc1.SetGenModeControl(b | BIT4);
	else tc1.SetGenModeControl(b & NOTBIT4);

}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckJamReader() 
{
	// TODO: Add code to cause reader data to be jammed into the
	//	generator (depending upon the status of check box)

	BYTE b, bByte;
	b = tc1.GetGenSync();	
	if (IsDlgButtonChecked(IDC_CHECK_JAM_READER))	//SET
		bByte = (b | BIT3);
	else bByte = (b & NOTBIT3);
	
	ProcessSyncChange(bByte);
	
}


//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckNojamub() 
{
	// TODO: Add code to keep the user data bits from the reader
	//	from being jammed into the generator. This will be disabled
	//	if the jam reader bit is NOT set/checked.
	
	BYTE b, bByte;
	b = tc1.GetGenSync();	
	if (IsDlgButtonChecked(IDC_CHECK_NOJAMUB))	//SET
		bByte = (b | BIT5);
	else bByte = (b & NOTBIT5);	
	ProcessSyncChange(bByte);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonCmpstart() 
{
	// TODO: Add code to get the edit box compare time and
	//	start the comparator, then set the edit box 1d/2e edit
	//	box with status bits from reads at those addresses.
	// Also set the status of "IDC_CHECK_CMPSTATUS" check box 
	// IDC_EDIT_1B_2D_READ
	BYTE b2Da, b2Db, b1B;
	int i;

	if (GetDlgItemText(IDC_EDIT_CMPINPUT, sBuffer, 12))
	{
		// get compare string DATA DWORD
		dWfour = (DWORD)sh1.ToHex(sBuffer);
		// write packed BCD data to compare registers
		bWrite = tc1.SetComparatorTime(dWfour);
		// enable the comparator 
		// 0x09 = Exact match + any ">" than under 1 sec.

		b2Da = tc1.Read1(0x002D); //TEMP
		b1B = tc1.GetCmpStatus();
		i = ((b1B & BIT7) ? 0 : 1);		
		//THIS IS REVERSE (next line makes state TOGGLE (active/inactive))

		bWrite = tc1.StartComparator(0x09);	//byte data does NOT do anything for PCI		

		b2Db = tc1.Read1(0x002D); //TEMP


		sh1.DWStrTm(dWfour, hhmmssff);
		SetDlgItemText(IDC_EDIT_CMPINPUT, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_CMPINPUT, "Error");  	

//	Sleep(15);	//allow time for cmp status to update
//	b1B = tc1.GetCmpStatus();
//	int i = ((b1B & BIT7) ? 1 : 0);
	//int i = ((tc1.GetCmpStatus() & BIT7) ? 1 : 0);
	CheckDlgButton(IDC_CHECK_CMPSTATUS, i);
	//CheckDlgButton(IDC_CHECK_CMPSTATUS, ((tc1.GetCmpStatus() & BIT7) ? 1 : 0));

	if (i)
		SetDlgItemText(IDC_BUTTON_CMPSTART, "Disable/Stop");
	else  SetDlgItemText(IDC_BUTTON_CMPSTART, "Enable/Start");



	wsprintf (hhmmssff,"%2.2X,%2.2X-%2.2X", b1B, b2Da, b2Db);
	SetDlgItemText(IDC_EDIT_1B_2D_READ, hhmmssff);

	//wsprintf (cBuff,"v%d", iFieldsTotal);
	//wsprintf (hhmmssff,"Nak Error %2.2X", b1B, b2D);

	//IDC_CHECK_CMPSTATUS (active checkbox)
	//IDC_EDIT_1B_2D_READ
	//IDC_EDIT_CMPINPUT (edit box for input)
	//IDC_RADIO_CMPREAD
	//IDC_RADIO_CMPGEN
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnRadioCmpread() 
{
	// TODO: Add code here to cause the comparator to use reader data
	//	for compares

	BYTE b = tc1.GetGenModeControl();
	tc1.SetGenModeControl(b | BIT1);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnRadioCmpgen() 
{
	// TODO: Add code here to cause the comparator to use generator data
	//	for compares	

	BYTE b = tc1.GetGenModeControl();
	tc1.SetGenModeControl(b & NOTBIT1);
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonNext() 
{
	// TODO: Add code to switch to the next device of the devices in this
	// machines control. Used only if more than ONE device is present and 
	// are not at the last device.
	//The following is TEST code,
	//This feature is still to be implememted
	if (pDlgSony422)
	{
		//pDlgSony422->SendMessage, msg, wp, lp);
		pDlgSony422->SendMessage(WM_AEC_TCUB, 0x55, 0x66);
		//::SendMessage(pDlgSony422->m_hWnd, WM_COMMAND, 0x00008887, 0x76543210);
	}

/*

  */
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnButtonPrev() 
{
	// TODO: Add code to switch to the previous device of the devices in this
	// machines control. Used only if more than ONE device is present and 
	// are not at the first device.	

/*
	//Still to be done 
  */
}


//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGenVitc() 
{
	// TODO: Add code to check the status of the four time code enable check
	// boxes and send the command that is appropriate for the boxes and mode
	// that is desired. 	
	BYTE b1, temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	
	if (IsDlgButtonChecked(IDC_CHECK_GEN_VITC))
	{
		b1 = (cmp0D | BIT3);
		//mode = TRUE;
	}
	else
	{
		b1 = (cmp0D & NOTBIT3);
		//mode = FALSE;
	}
	cmd = (b1 & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)

	

	if (tc1.GensLtc() || tc1.GensVitc())
	{

		//Gen output operating mode status (4A/45h)========================
		if (tc1.BrdType() == 4)	//PCI
		{
			temp = tc1.Read1(0x004A);	//pci
			if (temp & 0x01)
				frz = 1;
			else frz = 0;
			if (temp & 0x02)
				able = 1;
			else able = 0;
		}
		else 
		{
			temp = tc1.Read1(0x0045);   //isa
			if (temp & 0x40)
				frz = 0;		//UNFrozen = 0
			else frz = 1;
			if (temp & 0x80)
				able = 0;		//DISabled =0
			else able = 1;
		}
	}
	

	tc1.SendCom(cmd);

	if (frz && able)	//gen is active normal
		tc1.SendCom(0x48);	//start again

	else if (frz)	//NOT frozen 
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4E); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
								//have a "status" that tells if board gen has
								//been running OR NOT. Just make it run (safer)
			//b = tc1.Read1(0x0045);
			//b = b & 0xBF;	//clr bit6=0
			//tc1.Write1(b, 0x0045);	
		}	
	}
	else if (able)	//ENABLED
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4B); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again
			//b = tc1.Read1(0x0045);
			//b = b & 0x7F;	//clr bit7=0
			//tc1.Write1(b, 0x0045);	
		}	
	}
	//IDC_CHECK_GEN_VITC
	//IDC_CHECK_GEN_LTC
	//IDC_CHECK_READ_VITC
	//IDC_CHECK_READ_LTC


}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckGenLtc() 
{
	// TODO: Add code to check the status of the four time code enable check
	// boxes and send the command that is appropriate for the boxes and mode
	// that is desired. 

	BYTE b1, temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	
	if (IsDlgButtonChecked(IDC_CHECK_GEN_LTC))
	{
		b1 = (cmp0D | BIT2);
		//mode = TRUE;
	}
	else
	{
		b1 = (cmp0D & NOTBIT2);
		//mode = FALSE;
	}
	cmd = (b1 & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)

	

	if (tc1.GensLtc() || tc1.GensVitc())
	{

		//Gen output operating mode status (4A/45h)========================
		if (tc1.BrdType() == 4)	//PCI
		{
			temp = tc1.Read1(0x004A);	//pci
			if (temp & 0x01)
				frz = 1;
			else frz = 0;
			if (temp & 0x02)
				able = 1;
			else able = 0;
		}
		else 
		{
			temp = tc1.Read1(0x0045);   //isa
			if (temp & 0x40)
				frz = 0;		//UNFrozen = 0
			else frz = 1;
			if (temp & 0x80)
				able = 0;		//DISabled =0
			else able = 1;
		}
	}
	

	tc1.SendCom(cmd);

	if (frz && able)	//gen is active normal
		tc1.SendCom(0x48);	//start again

	else if (frz)	//NOT frozen 
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4E); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
								//have a "status" that tells if board gen has
								//been running OR NOT. Just make it run (safer)
			//b = tc1.Read1(0x0045);
			//b = b & 0xBF;	//clr bit6=0
			//tc1.Write1(b, 0x0045);	
		}	
	}
	else if (able)	//ENABLED
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4B); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again
			//b = tc1.Read1(0x0045);
			//b = b & 0x7F;	//clr bit7=0
			//tc1.Write1(b, 0x0045);	
		}	
	}
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckReadVitc() 
{
	// TODO: Add code to check the status of the four time code enable check
	// boxes and send the command that is appropriate for the boxes and mode
	// that is desired. 	

	BYTE b1, temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	
	if (IsDlgButtonChecked(IDC_CHECK_READ_VITC))
	{
		b1 = (cmp0D | BIT1);
		//mode = TRUE;
	}
	else
	{
		b1 = (cmp0D & NOTBIT1);
		//mode = FALSE;
	}
	cmd = (b1 & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)

	

	if (tc1.GensLtc() || tc1.GensVitc())
	{

		//Gen output operating mode status (4A/45h)========================
		if (tc1.BrdType() == 4)	//PCI
		{
			temp = tc1.Read1(0x004A);	//pci
			if (temp & 0x01)
				frz = 1;
			else frz = 0;
			if (temp & 0x02)
				able = 1;
			else able = 0;
		}
		else 
		{
			temp = tc1.Read1(0x0045);   //isa
			if (temp & 0x40)
				frz = 0;		//UNFrozen = 0
			else frz = 1;
			if (temp & 0x80)
				able = 0;		//DISabled =0
			else able = 1;
		}
	}
	

	tc1.SendCom(cmd);

	if (frz && able)	//gen is active normal
		tc1.SendCom(0x48);	//start again

	else if (frz)	//NOT frozen 
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4E); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
								//have a "status" that tells if board gen has
								//been running OR NOT. Just make it run (safer)
			//b = tc1.Read1(0x0045);
			//b = b & 0xBF;	//clr bit6=0
			//tc1.Write1(b, 0x0045);	
		}	
	}
	else if (able)	//ENABLED
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4B); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again
			//b = tc1.Read1(0x0045);
			//b = b & 0x7F;	//clr bit7=0
			//tc1.Write1(b, 0x0045);	
		}	
	}
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckReadLtc() 
{
	// TODO: Add code to check the status of the four time code enable check
	// boxes and send the command that is appropriate for the boxes and mode
	// that is desired. 	
	BYTE b1, temp, cmd;
	int frz, able;
	frz = 0;
	able = 0;
	
	if (IsDlgButtonChecked(IDC_CHECK_READ_LTC))
	{
		b1 = (cmp0D | BIT0);
		//mode = TRUE;
	}
	else
	{
		b1 = (cmp0D & NOTBIT0);
		//mode = FALSE;
	}
	cmd = (b1 & 0x0F) + 0x20;	//command 2xh (PCI ALL and ISA PC-VLTC)

	

	if (tc1.GensLtc() || tc1.GensVitc())
	{

		//Gen output operating mode status (4A/45h)========================
		if (tc1.BrdType() == 4)	//PCI
		{
			temp = tc1.Read1(0x004A);	//pci
			if (temp & 0x01)
				frz = 1;
			else frz = 0;
			if (temp & 0x02)
				able = 1;
			else able = 0;
		}
		else 
		{
			temp = tc1.Read1(0x0045);   //isa
			if (temp & 0x40)
				frz = 0;		//UNFrozen = 0
			else frz = 1;
			if (temp & 0x80)
				able = 0;		//DISabled =0
			else able = 1;
		}
	}
	

	tc1.SendCom(cmd);

	if (frz && able)	//gen is active normal
		tc1.SendCom(0x48);	//start again

	else if (frz)	//NOT frozen 
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4E); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again //NOTE: The ISA boards do NOT
								//have a "status" that tells if board gen has
								//been running OR NOT. Just make it run (safer)
			//b = tc1.Read1(0x0045);
			//b = b & 0xBF;	//clr bit6=0
			//tc1.Write1(b, 0x0045);	
		}	
	}
	else if (able)	//ENABLED
	{
		if (tc1.BrdType() == 4)	//PCI
			tc1.SendCom(0x4B); //PCI
		else //ISA
		{						
			tc1.SendCom(0x48);	//start again
			//b = tc1.Read1(0x0045);
			//b = b & 0x7F;	//clr bit7=0
			//tc1.Write1(b, 0x0045);	
		}	
	}

}
//=======================================================================
//IDC_CHECK_SIO_GENERIC_DLG
void CAecMfc32TimeCodeDlg::OnCheckSioGenericDlg()	
{
	DWBYTES modp;
	if (!tc1.HasSerial())
	{
		CheckDlgButton(IDC_CHECK_SIO_GENERIC_DLG, 0);
		GetDlgItem(IDC_CHECK_SIO_GENERIC_DLG)->EnableWindow(FALSE);
		return;
	}
	if (IsDlgButtonChecked(IDC_CHECK_SIO_GENERIC_DLG))
	{

		GetDlgItem(IDC_CHECK_SONY422_DLG)->EnableWindow(FALSE);
		pDlgSIO = new CAecSio(this);
		if (pDlgSIO != NULL)
		{
			tc1.SendCom(0x5B);
			modp.d = tc1.Read4(0x001C);

			if (tc1.HasL21())
			{
				modp.b.f = 0x80;
				modp.b.s = 0x40;
				modp.b.m = 0x40;			
				modp.b.h = 0x40;
			}				
			else 
			{
				modp.d = 0x40404040;
			}
			tc1.Write4(modp.d, 0x0020);
			tc1.SendCom(0x5A);	//enable MODP as assigned above
			//use 3 of the 4 MODP DWORD buffers for RX (write 0x40 to addr 0x0021/2/3)
			//Save ONE for L21 if enabled (write 0x80 to addr 0x0020)			//ret = pDlgSIO->Create(nIDtemp,CWnd*pParend=null);
			BOOL ret = pDlgSIO->Create(CAecSio::IDD, this);
			if (!ret)	//failed
				AfxMessageBox("Error Creating SERIAL Control Dialog Box", MB_OK, NULL);
			pDlgSIO->ShowWindow(SW_SHOW);		
		}
		else 
			AfxMessageBox("Error Creating SERIAL Dialog Object", MB_OK, NULL);
	}

	else 
	{
		GetDlgItem(IDC_CHECK_SONY422_DLG)->EnableWindow(TRUE);
		if (pDlgSIO != NULL)
		{
			pDlgSIO->EndDialog(TRUE);
			delete pDlgSIO;
		}
		pDlgSIO = NULL;
	}	
}

//=======================================================================
//IDC_CHECK_SONY422_DLG
void CAecMfc32TimeCodeDlg::OnCheckSony422Dlg() //Sony RS422 VTR....
{

	DWBYTES modp;
	if (!tc1.HasSerial())
	{
		CheckDlgButton(IDC_CHECK_SONY422_DLG, 0);
		GetDlgItem(IDC_CHECK_SONY422_DLG)->EnableWindow(FALSE);
		return;
	}
	if (IsDlgButtonChecked(IDC_CHECK_SONY422_DLG))
	{
		GetDlgItem(IDC_CHECK_SIO_GENERIC_DLG)->EnableWindow(FALSE);
		pDlgSony422 = new CAecSony422(this);
		if (pDlgSony422 != NULL)
		{
			tc1.SendCom(0x5B);
			modp.d = tc1.Read4(0x001C);

			if (tc1.HasL21())
			{
				modp.b.f = 0x80;
				modp.b.s = 0x40;
				modp.b.m = 0x40;			
				modp.b.h = 0x40;
			}				
			else 
			{
				modp.d = 0x40404040;
			}
			tc1.Write4(modp.d, 0x0020);
			tc1.SendCom(0x5A);	//enable MODP as assigned above
			//use 3 of the 4 MODP DWORD buffers for RX (write 0x40 to addr 0x0021/2/3)
			//Save ONE for L21 if enabled (write 0x80 to addr 0x0020)

			tc1.InitSonySerial();
			//ret = pDlgSony422->Create(nIDtemp,CWnd*pParend=null);
			BOOL ret = pDlgSony422->Create(CAecSony422::IDD, this);
			if (!ret)	//failed
				AfxMessageBox("Error Creating Sony422 Dialog Box", MB_OK, NULL);
			pDlgSony422->ShowWindow(SW_SHOW);		
		}
		else 
			AfxMessageBox("Error Creating Sony422 Dialog Object", MB_OK, NULL);
	}

	else 
	{
		GetDlgItem(IDC_CHECK_SIO_GENERIC_DLG)->EnableWindow(TRUE);
		if (pDlgSony422 != NULL)
		{
			pDlgSony422->EndDialog(TRUE);
			delete pDlgSony422;
		}
		pDlgSony422 = NULL;
	}

/*		rx_mode = INTERRUPT_RX;
		//rx_mode = OPTIONAL_RX;	//older ISA only code used this
			hwndSIO = CreateDialog(
			hThisInst, //hinstSIO,
			MAKEINTRESOURCE(IDD_XSERIAL_OPTION),
			hwnd, 
			(DLGPROC)AecSIO);
*/	
}
//=======================================================================
//CAecL21* pDlgL21;
void CAecMfc32TimeCodeDlg::OnCheckL21Dlgbox() 
{
	//IDC_CHECK_L21_DLGBOX
	if (!tc1.HasL21())
	{
		CheckDlgButton(IDC_CHECK_L21_DLGBOX, 0);
		GetDlgItem(IDC_CHECK_L21_DLGBOX)->EnableWindow(FALSE);
		return;
	}
	DWBYTES modp;
	if (IsDlgButtonChecked(IDC_CHECK_L21_DLGBOX))
	{
		tc1.ResetL21Buffer();
		pDlgL21 = new CAecL21(this);
		if (pDlgL21 != NULL)
		{
			tc1.SendCom(0x5B);
			Sleep(50);
			modp.d = tc1.Read4(0x001C);

			if (tc1.HasSerial())
				modp.b.f = 0x80;
			else 
			{
				modp.d = 0x80808080;
			}
			tc1.Write4(modp.d, 0x0020);
			tc1.SendCom(0x5A);	//enable MODP as assigned above
			Sleep(50);
			//ret = pDlgL21->Create(nIDtemp,CWnd*pParend=null);
			BOOL ret = pDlgL21->Create(CAecL21::IDD, this);
			//clear then reset the "L21 interrupt enable bit"
			tc1.AndIntEnables(0x3F);	//clr bit 6
			Sleep(100);
			tc1.OrIntEnables(0x40);		//set bit 6
			if (!ret)	//failed
				AfxMessageBox("Error Creating L21 Reader Dialog Box", MB_OK, NULL);
			pDlgL21->ShowWindow(SW_SHOW);		
		}
		else 
			AfxMessageBox("Error Creating L21 Dialog Object", MB_OK, NULL);
	}

	else 
	{
		if (pDlgL21 != NULL)
		{
			pDlgL21->EndDialog(TRUE);
			delete pDlgL21;
			tc1.ResetL21Buffer();
		}
		pDlgL21 = NULL;
	}	
}
//=======================================================================
//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckOsdDlgbox() 
{
	// TODO: Add code to open or close the OSD option dialog box.
	//IDC_CHECK_OSD_DLGBOX


	if ((tc1.BrdType() != 4) || ((tc1.Read1(0x0008) & BIT3) == 0x00))
	{
		CheckDlgButton(IDC_CHECK_OSD_DLGBOX, 0);
		GetDlgItem(IDC_CHECK_OSD_DLGBOX)->EnableWindow(FALSE);
		return;
	}		

	if (IsDlgButtonChecked(IDC_CHECK_OSD_DLGBOX))
	{
		pDlgOSD = new CAecOSDdlg(this);
		//pDlgOSD = new CDlgTest(this);
		if (pDlgOSD != NULL)
		{
			//ret = pDlgOSD->Create(nIDtemp,CWnd*pParend=null);
			BOOL ret = pDlgOSD->Create(CAecOSDdlg::IDD, this);
			if (!ret)	//failed
				AfxMessageBox("Error Creating OSD Dialog Box", MB_OK, NULL);
			pDlgOSD->ShowWindow(SW_SHOW);		
		}
		else 
			AfxMessageBox("Error Creating OSD Dialog Object", MB_OK, NULL);
	}

	else 
	{
		if (pDlgOSD != NULL)
		{
			pDlgOSD->EndDialog(TRUE);
			delete pDlgOSD;
		}
		pDlgOSD = NULL;
	}
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIntL21on() 
{
	// set/clear interrupt enable register bit6

	if (IsDlgButtonChecked(AEC_CHECK_INT_L21ON))
	{
		tc1.ResetL21Buffer();
		tc1.OrIntEnables(BIT6);
	}
	else tc1.AndIntEnables(NOTBIT6);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIntCmpon() 
{
	// set/clear interrupt enable register bit5

	if (IsDlgButtonChecked(AEC_CHECK_INT_CMPON))
		tc1.OrIntEnables(BIT5);
	else tc1.AndIntEnables(NOTBIT5);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIntRxon() 
{
	// set/clear interrupt enable register bit4

	if (IsDlgButtonChecked(AEC_CHECK_INT_RXON))
		tc1.OrIntEnables(BIT4);
	else tc1.AndIntEnables(NOTBIT4);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIntTxon() 
{
	// set/clear interrupt enable register bit3

	if (IsDlgButtonChecked(AEC_CHECK_INT_TXON))
		tc1.OrIntEnables(BIT3);
	else tc1.AndIntEnables(NOTBIT3);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIntGenon() 
{
	// set/clear interrupt enable register bit2

	if (IsDlgButtonChecked(AEC_CHECK_INT_GENON))
		tc1.OrIntEnables(BIT2);
	else tc1.AndIntEnables(NOTBIT2);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIntVidon() 
{
	// set/clear interrupt enable register bit1

	if (IsDlgButtonChecked(AEC_CHECK_INT_VIDON))
		tc1.OrIntEnables(BIT1);
	else tc1.AndIntEnables(NOTBIT1);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIntRdron() 
{
	// set/clear interrupt enable register bit0

	if (IsDlgButtonChecked(AEC_CHECK_INT_RDRON))
		tc1.OrIntEnables(BIT0);
	else tc1.AndIntEnables(NOTBIT0);
	
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCheckIsrOnly() 
{
	// TODO: Add code to switch to ISR operation or back to
	//	polled operation. Checked=ISR.


	if (IsDlgButtonChecked(IDC_CHECK_ISR_ONLY))
	{
		//init the CAec class for ISR operations
		b_ISRtranstion = true;
		Sleep(50);
		tc1.DoISR(true);		
		Sleep(50);
		b_ISRtranstion = false;
	}
	else 
	{
		//stop CAec class ISR operation!
		b_ISRtranstion = true;
		Sleep(50);
		tc1.DoISR(false);		
		Sleep(50);
		b_ISRtranstion = false;	}	  	
}


//=======================================================================
void CAecMfc32TimeCodeDlg::OnSimulateTimer() 
{
	
	int i = 0;
	BOOL bGotInt = false;

	for (i=0; i<30; i++)
	{
		do 
		{
			bGotInt = Poll_And_Process();
			Sleep(1);

		} while (bGotInt || tc1.PendingIntBuffered());
		Sleep(100);
		//UpdateStatus_N_Signals();

	}
	UpdateStatus_N_Signals();
	
	MessageBeep(-1);

	//m_Dlg_Timer = SetTimer(1, 10, 0);
	return;
}
//=======================================================================
void CAecMfc32TimeCodeDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default	
	//CDialog::OnTimer(nIDEvent);
	
	int i = 0;
	BOOL bGotInt = false;
	KillTimer(m_Dlg_Timer);
//	do 
//	{
//		do
//		{
//			bGotInt = Poll_And_Process();
//			//Sleep(1);
//		} while (bGotInt);	//PendingIntBuffered()
//		i++;
//	} while (i < 3);

	if (nIDEvent == 1)
	{
		if (!b_ISRtranstion)
		{
			do 
			{
				bGotInt = Poll_And_Process();
				//Sleep(10); //added 7/03 for new driver debugging
				i++;

			} while (bGotInt   && (i < 20));
			//} while ((bGotInt || tc1.PendingIntBuffered())  && (i < 20));


			//if (bGotInt)
			m_IntUpdateCount++;
			if (m_IntUpdateCount > 25)
			{
				UpdateStatus_N_Signals();
				m_IntUpdateCount = 0;
			}
			
	//		if (i == 10)
	//		{
	//			i = 0;
	//			//MessageBeep(0xFFFFFFFF);
	//		}
		}
//		MessageBeep(-1);
		//11-25-02 ADD NEXT BACK
//		if (m_PollFast)
//			m_Dlg_Timer = SetTimer(1, 10, 0);
//		else
			m_Dlg_Timer = SetTimer(1, 10, 0);
	}
	return;
}


//=======================================================================
void CAecMfc32TimeCodeDlg::OnClose() 
{
	//OnCancel();
	CDialog::OnClose();
}

//=======================================================================
void CAecMfc32TimeCodeDlg::OnCancel() 
{
/*
	if (pDlgOSD)
		delete pDlgOSD;
	if (pDlgSony422)
		delete pDlgSony422;
	if (pDlgSIO)
		delete pDlgSIO;
	if (pDlgL21)
		delete pDlgL21;

	// TODO: Add shut down and cleanup code here. The program is exiting.
	// makes sure to clear any hardware interrupts if the IRQs are enabled.
	if (m_Dlg_Timer)
	{
		//MessageBeep(-1);
		KillTimer(m_Dlg_Timer);
		m_Dlg_Timer = 0;
	}
	//do the rest of the cleanup of the PC-TC device(s)
	tc1.exiting = TRUE;
		// TODO: Force an interrupt to make sure ISR loop ends.
		// --> For 'Smart' boards, just send a command to 3FF
		//		this will cause an interrupt
		//Purpose: This will allow the ISR thread to exit cleanly
		//			without leaving residual effects 
		tc1.SendCom(0x5B);	// will generate an int (PCI ok, NAK reply for ISA)
							//Choose any Command wanted ie: 0x5B = MDOP status


*/

	CDialog::OnCancel();
}

//=======================================================================
BOOL CAecMfc32TimeCodeDlg::Poll_And_Process()
{
	BOOL	bEvent = FALSE;

			if (tc1.Any_event()) 
			{	
				bEvent = TRUE;
				// go process the "events"
				if (tc1.brk_event)
 				{
					tc1.brk_event = FALSE;
					ProcessIntEventCode(0x8A);
				}
				if (tc1.tx_event)
				{
					tc1.tx_event = FALSE;
					ProcessIntEventCode(0x89);
				}
				if (tc1.nak_event)
				{
					tc1.nak_event = FALSE;
					tc1.cmd_event = FALSE;	//only ONE value is saved in cmd_ret
					ProcessIntEventCode(tc1.cmd_ret);
				}
				if (tc1.cmd_event)
				{
					tc1.cmd_event = FALSE;
					ProcessIntEventCode(tc1.cmd_ret);
				}
				if (tc1.cmp_event)
				{
					tc1.cmp_event = FALSE;
					ProcessIntEventCode(0x50);
				}
				if (tc1.rx_event)
				{
					tc1.rx_event = FALSE;
					ProcessIntEventCode(0x88);
					//RXready = TRUE;
					//if (RXready && IsWindow(hwndSIO))
					//	ProcessRXready(hwnd, rx_mode);

				}
				if (tc1.gen_event)
				{
					tc1.gen_event = FALSE;
					ProcessIntEventCode(0x4C);
				}
				if (tc1.vid_event)
				{
					tc1.vid_event = FALSE;
					ProcessIntEventCode(0x44);
				}
				if (tc1.L21_event)
				{
					tc1.L21_event = FALSE;
					ProcessIntEventCode(0x1E);
				}
				if (tc1.read_event)
				{
					tc1.read_event = FALSE;
					ProcessIntEventCode(0x13);
				}

			}  

	return bEvent;

}

//=======================================================================
void CAecMfc32TimeCodeDlg::ProcessIntEventCode(int IntId)
{
	DWORD dwTemp1, dwTemp2;
	BYTE  bTemp;
	WORD  w[20];
	DWORD  dw[10];
	int		i = 0;

//DWORD cmpRtb, cmpRub, cmpGtb, cmpGub;
//BYTE cmpReb, cmpGeb, cmp0C, cmp0D;

	switch (IntId)
	{
		case 0x11:	// LTC time code reader (PCI - if 2C.6 = '1')
		case 0x12:	// VITC time code reader (PCI - if 28.6 = '1')
		case 0x13:	//time code reader ID / AUTO (PCI & smart ISA)
			//IDC_EDIT_TBREADER, IDC_EDIT_UBREADER, IDC_EDIT_DFREADER, IDC_EDIT_CFREADER
			dwTemp1 = tc1.tcR.t ;
			dwTemp2 = tc1.tcR.u;
			bTemp = (tc1.tcR.e & 0xF3);	//mask the field (bit3/2 (NTSC/PAL)) to limit updates
			if (dwTemp1 != cmpRtb)
			{
				cmpRtb = dwTemp1;
				sh1.DWStrTm(dwTemp1, hhmmssff);
				SetDlgItemText(IDC_EDIT_TBREADER, hhmmssff);
			}
			if (dwTemp2 != cmpRub)
			{
				cmpRub = dwTemp2;
				sh1.DWStrTm(dwTemp2, hhmmssff);
				SetDlgItemText(IDC_EDIT_UBREADER, hhmmssff);
			}
			if (bTemp != cmpReb)
			{
				cmpReb = bTemp;
				if (bTemp & 0x80)
					SetDlgItemText(IDC_EDIT_DFREADER, "YES");
				else SetDlgItemText(IDC_EDIT_DFREADER, "NO");
				if (bTemp & 0x40)
					SetDlgItemText(IDC_EDIT_CFREADER, "YES");
				else SetDlgItemText(IDC_EDIT_CFREADER, "NO");;
			}
			break;

		case 0x1E:	//Line 21 reader ID (VITC rdr mode & have 2E.6 = '1' 
			//iL21Total++;
			if (pDlgL21 != NULL)
			{
				//send to L21 dialog to handle the CC/XDS data!!
				pDlgL21->ReceiveData(tc1.GetL21DwStr(dw, 8), dw);
			}
			else
			{				
				//(display to this edit box)
				WriteHexStringToEditBox(IDC_EDIT_L21_OUT, tc1.GetL21DwStr(dw, 8), dw);	//dwords,not words
				tc1.ResetL21Buffer();	//?
			}
			break;

		case 0x4C:	//time code generator ID		
			dwTemp1 = tc1.tcG.t ;			
			dwTemp2 = tc1.tcG.u;
			bTemp = (tc1.tcG.e & 0xF3);	//mask the field (bit3/2 (NTSC/PAL)) to limit updates
			if (dwTemp1 != cmpGtb)	//time
			{
				cmpGtb = dwTemp1;
				sh1.DWStrTm(dwTemp1, hhmmssff);
				SetDlgItemText(IDC_EDIT_TBGEN_OUTPUT, hhmmssff);
			}
			if (dwTemp2 != cmpGub)	//user
			{
				cmpGub = dwTemp2;
				sh1.DWStrTm(dwTemp2, hhmmssff);
				SetDlgItemText(IDC_EDIT_UBGEN_OUTPUT, hhmmssff);
			}
			if (bTemp != cmpGeb)	//eb
			{
				cmpGeb = bTemp;
				if (bTemp & 0x80)
					SetDlgItemText(IDC_EDIT_DFGEN_OUTPUT, "YES");
				else SetDlgItemText(IDC_EDIT_DFGEN_OUTPUT, "NO");
				if (bTemp & 0x40)
					SetDlgItemText(IDC_EDIT_CFGEN_OUTPUT, "YES");
				else SetDlgItemText(IDC_EDIT_CFGEN_OUTPUT, "NO");;
			}
			break;

		case 0x44:	//video field ID
		case 0x45:	//video SUB field interrupt ID (custom firmware)

			/*	iFieldsTotal = tc1.vidCounter;
				if (tmrVIDup.msT() > 150)   //only update so often at max
				{
					wsprintf (cBuff,"v%d", iFieldsTotal);
					SetDlgItemText(hwndDlg, AEC_VID_FRAMES, cBuff); 
					tmrVIDup.Zero();
				}
				break;
			*/
			wsprintf (hhmmssff,"%d", tc1.vidCounter);
			SetDlgItemText(IDC_EDIT_VID_COUNT, hhmmssff);
			break;

		case 0x8A:	//RX break  byte ID
//			if (iTimeOutEvents > 0)
//				iTimeOutEvents--;
//			tmrSIO.Zero();		//reset timer
//			if (*lpRxBusy) //*lpRxDone || 
//				RXready = TRUE;

			if (pDlgSIO != NULL)
			{
				//send to SIO generic dialog
			}
			else if (pDlgSony422 != NULL)
			{
				//send to Sony422 dialog
			}
			else
			{
				//flush, not used
			}

			break;
		case 0x88:	//RX data byte ID
				//check for 10ms timeout
				//flag error if timeout
				//Put command in Que to read byte (0x82)
				//reset 10ms timer
//			if (iTimeOutEvents > 0)
//				iTimeOutEvents--;
//
//			tmrSIO.Zero();		//reset timer
//			if (*lpRxBusy) //*lpRxDone || 
//				RXready = TRUE;
			i++;
			if (pDlgSIO != NULL)
			{
				//send to SIO generic dialog
				pDlgSIO->ReceiveData(tc1.GetRxWStr(w, 20), w);
			}
			else if (pDlgSony422 != NULL)
			{
				//send to Sony422 dialog
				pDlgSony422->ReceiveData(tc1.GetRxWStr(w, 20), w);

			}
			else
			{
				//IDC_EDIT_RX_OUT (display to this edit box)
				WriteHexStringToEditBox(IDC_EDIT_RX_OUT, tc1.GetRxWStr(w, 10), w);
			}
			
			break;

		case 0x89:	//TX complete ID
			iTimeOutEvents++;
//			if (iTimeOutEvents > 5) 
//			{
//				//MessageBeep(0xFFFFFFFF);	//remove after debugging
//				MessageBox( "The VTR is NOT responding."
//					"\nCheck cable","Serial IO", MB_OK);
//				// send a message to the SIO dialog box to close it
////				PostMessage(hwndSIO, WM_COMMAND, IDCANCEL, 0);//close dialog if errors
//													//add back after debugging
//			}
//
//			//tc1.InitRx();
//
//			rxIndex = 0;
//			//inititialize/reset 10ms timer
//			tmrSIO.Zero(); 
//			if (*lpRxBusy && (rx_mode == OPTIONAL_RX))	// if not using rx interrupt modes
//				RXready = TRUE;

			if (pDlgSIO != NULL)
			{
				//send to SIO generic dialog
			}
			else if (pDlgSony422 != NULL)
			{
				//send to Sony422 dialog
				//tc1.InitRx();
				pDlgSony422->TxComplete = TRUE;
				//MessageBeep(-1);
				i++;
			}
			else
			{
				//flush, not used
			}

			break;
	
		case 0x50:	//time code compare MATCH ID				
			CheckDlgButton(IDC_CHECK_CMPSTATUS, ((tc1.GetCmpStatus() & BIT7) ? 1 : 0));
			SetDlgItemText(IDC_BUTTON_CMPSTART, "Enable/Start");
			//MessageBeep(-1);
			MessageBox( "MATCH!", "Time Code Comparator", MB_OK);
			//set up for next compare...???
			break;

		case 0xF0:	// NAK  error of some sort(0xFx)
		case 0xF1:
		case 0xF2:
		case 0xF3:
		case 0xF4:
		case 0xF5:
		case 0xF6:
		case 0xF7:
		case 0xF9:
		case 0xFA:
		case 0xFB:
		case 0xFC:
		case 0xFD:
		case 0xFE:
		case 0xFF:
			MessageBox("Error code F?h", "Received Interrupt Code", MB_OK);
			break;
		case 0xF8:	//VGWE_Int, vitc generator write error ID
					//put code here to flag this error
			break;
	
		default:
			// ISR processing of command response interrupts
				// NOT used if using polling method!
			break;
	} //END of Interrupt ID cases
	return;// TRUE;
}

//SetDlgItemText... set the text on a Dlg control
//=======================================================================
void CAecMfc32TimeCodeDlg::UpdateStatus_N_Signals()
{
	BYTE temp;
	//Operating mode status (0Dh)=====================================
	temp = tc1.ModeStatus();
//	if (tc1.BrdType() == 4)	//PCI
//		temp = tc1.Read1(0x000D);	//pci
//	else 
//		temp = tc1.Read1(0x03E8);   //isa
	if (cmp0D != temp)
	{
		//( wOffset < 0x50 ) ? 0x10 : 0x20
		if ((cmp0D & 0x80 ) != (temp & 0x80))	//7
			CheckDlgButton(IDC_CHECK_DIAGMODE, ((temp & 0x80) ? 1 : 0));
		//if ((cmp0D & 0x40 ) != (temp & 0x40))	//6
		//	CheckDlgButton(nID, ((temp & 0x40) ? 1 : 0));
		if ((cmp0D & 0x20 ) != (temp & 0x20))	//5
		{
			CheckDlgButton(IDC_CHECK_LTCSELECTMODE, ((temp & 0x20) ? 1 : 0));
			CheckDlgButton(IDC_CHECK_VITCSELECTMODE, ((temp & 0x20) ? 0 : 1));
		}


		if (filmAble)
		{

			if ((cmp0D & 0x50 ) != (temp & 0x50))	// 6/4
			{
				if (temp & 0x40)
				{
					//CheckDlgButton(IDC_CHECK_FILMMODE, ((temp & 0x40) ? 1 : 0));
					CheckDlgButton(IDC_CHECK_FILMMODE, 1);
					CheckDlgButton(IDC_CHECK_EBUMODE, 0);	//Not in this mode
					CheckDlgButton(IDC_CHECK_SMPTEMODE,0);	//Not in this mode
				}
				else
				{
					CheckDlgButton(IDC_CHECK_EBUMODE, ((temp & 0x10) ? 1 : 0));
					CheckDlgButton(IDC_CHECK_SMPTEMODE, ((temp & 0x10) ? 0 : 1));
					CheckDlgButton(IDC_CHECK_FILMMODE, 0);
				}
			}
		}
		else if ((cmp0D & 0x10 ) != (temp & 0x10))	//4
		{
			CheckDlgButton(IDC_CHECK_EBUMODE, ((temp & 0x10) ? 1 : 0));
			CheckDlgButton(IDC_CHECK_SMPTEMODE, ((temp & 0x10) ? 0 : 1));
		}


		if ((cmp0D & 0x08 ) != (temp & 0x08))	//3
		{
			CheckDlgButton(IDC_CHECK_VGENMODE, ((temp & 0x08)  ? 1 : 0 ));		
			//CheckDlgButton(IDC_CHECK_VGENMODE, (temp & 0x08));
			CheckDlgButton(IDC_CHECK_GEN_VITC, ((temp & 0x08)  ? 1 : 0 ));
		}
		if ((cmp0D & 0x04 ) != (temp & 0x04))	//2
		{
			CheckDlgButton(IDC_CHECK_LGENMODE, ((temp & 0x04)  ? 1 : 0 ));
			//CheckDlgButton(IDC_CHECK_LGENMODE, (temp & 0x04));
			CheckDlgButton(IDC_CHECK_GEN_LTC, ((temp & 0x04)  ? 1 : 0 ));
		}
		if ((cmp0D & 0x02 ) != (temp & 0x02))	//1
		{
			CheckDlgButton(IDC_CHECK_VL21RDRMODE, ((temp & 0x02)  ? 1 : 0 ));
			//CheckDlgButton(IDC_CHECK_VL21RDRMODE, (temp & 0x02));
			CheckDlgButton(IDC_CHECK_READ_VITC, ((temp & 0x02)  ? 1 : 0 ));
		}
		if ((cmp0D & 0x01 ) != (temp & 0x01))	//0
		{
			CheckDlgButton(IDC_CHECK_LRDRMODE, ((temp & 0x01)  ? 1 : 0 ));
			//CheckDlgButton(IDC_CHECK_LRDRMODE, (temp & 0x01));
			CheckDlgButton(IDC_CHECK_READ_LTC, ((temp & 0x01)  ? 1 : 0 ));

		}

		cmp0D = temp;
	}
	/*
					if (IsDlgButtonChecked(hwndDlg, AEC_INT_READ_OFF)) 
						bReadOff = TRUE; // bit 0
					else bReadOff = FALSE;
     */

	//signal status (0Ch)==========================================
	if (tc1.BrdType() == 4)	//PCI
		temp = (tc1.Read1(0x000C) & 0x7F);   //pci, mask bit7
			//		 bits  => 6=L21 input data OK,
							//5=VITC input data OK
							//4=LTC input data OK
							//3=Wide sync pluses detected
							//2=
							//1=odd video field
							//0=video input OK
	

	else 
		temp = (tc1.Read1(0x0049) & 0x1F);   //isa, mask bits 7/6/5

							//4=LTC input data OK
							//3=Wide sync pluses detected
							//2=
							//1=odd video field
							//0=video input OK

	if (cmp0C != temp)
	{
		//if ((cmp0C & 0x80 ) != (temp & 0x80))
		//	CheckDlgButton(nID, ((temp & 0x80)  ? 1 : 0 ));
		if ((cmp0C & 0x40 ) != (temp & 0x40))	//6
			CheckDlgButton(IDC_CHECK_L21STAT, ((temp & 0x40)  ? 1 : 0 ));
		if ((cmp0C & 0x20 ) != (temp & 0x20))	//5
			CheckDlgButton(IDC_CHECK_VITCSTAT, ((temp & 0x20)  ? 1 : 0 ));
		if ((cmp0C & 0x10 ) != (temp & 0x10))	//4
			CheckDlgButton(IDC_CHECK_LTCSTAT, ((temp & 0x10)  ? 1 : 0 ));

		if ((cmp0C & 0x08 ) != (temp & 0x08))	//3
			CheckDlgButton(IDC_CHECK_VSYNCSTAT, ((temp & 0x08)  ? 1 : 0 ));
		//if ((cmp0C & 0x04 ) != (temp & 0x04))	//2
		//	CheckDlgButton(nID, ((temp & 0x04)  ? 1 : 0 ));
//		if ((cmp0C & 0x02 ) != (temp & 0x02))	//1
//		{
//			if ((temp & 0x01))	//check the video OK first
//				CheckDlgButton(IDC_CHECK_FIELDSTAT, ((temp & 0x02)  ? 1 : 0 ));		
//			else CheckDlgButton(IDC_CHECK_FIELDSTAT, 0);	//turn OFF 
//		}
		if ((cmp0C & 0x01 ) != (temp & 0x01))	//0
			CheckDlgButton(IDC_CHECK_VIDSTAT, ((temp & 0x01)  ? 1 : 0 ));
		cmp0C = temp;
	}

	//Interupt Enables (2E/3F0)==========================================
	if (tc1.BrdType() == 4)	//PCI
		temp = (tc1.Read1(0x002E) & 0x7F);   //pci, mask bit7
	else 
		temp = (tc1.Read1(0x03F0) & 0x7F);   //isa, mask bit7
			//		 bits  => 6= L21 Data Reader
							//5= TC comparator
							//4= Serial RX
							//3= Serial TX
							//2= TC Gen
							//1= video Field 
							//0= TC Reader 
	if (cmp2E != temp)
	{
		//if ((cmp2E & 0x80 ) != (temp & 0x80))	//7
		//	CheckDlgButton(nID, ((temp & 0x80) ? 1 : 0));
		if ((cmp2E & 0x40 ) != (temp & 0x40))	//6
			CheckDlgButton(AEC_CHECK_INT_L21ON, ((temp & 0x40) ? 1 : 0));
		if ((cmp2E & 0x20 ) != (temp & 0x20))	//5
			CheckDlgButton(AEC_CHECK_INT_CMPON, ((temp & 0x20) ? 1 : 0));
		if ((cmp2E & 0x10 ) != (temp & 0x10))	//4
			CheckDlgButton(AEC_CHECK_INT_RXON, ((temp & 0x10) ? 1 : 0));

		if ((cmp2E & 0x08 ) != (temp & 0x08))	//3
			CheckDlgButton(AEC_CHECK_INT_TXON, ((temp & 0x08)  ? 1 : 0 ));
		if ((cmp2E & 0x04 ) != (temp & 0x04))	//2
			CheckDlgButton(AEC_CHECK_INT_GENON, ((temp & 0x04)  ? 1 : 0 ));
		if ((cmp2E & 0x02 ) != (temp & 0x02))	//1
			CheckDlgButton(AEC_CHECK_INT_VIDON, ((temp & 0x02)  ? 1 : 0 ));
		if ((cmp2E & 0x01 ) != (temp & 0x01))	//0
			CheckDlgButton(AEC_CHECK_INT_RDRON, ((temp & 0x01)  ? 1 : 0 ));
		cmp2E = temp;
		//AEC_CHECK_INT_L21ON
		//AEC_CHECK_INT_CMPON
		//AEC_CHECK_INT_RXON
		//AEC_CHECK_INT_TXON
		//AEC_CHECK_INT_GENON
		//AEC_CHECK_INT_VIDON
		//AEC_CHECK_INT_RDRON
	}
}

//=======================================================================
void CAecMfc32TimeCodeDlg::InitStatus_N_Signals()
{
	BYTE temp;

	//VERIFY(buttonUP.SubclassDlgItem(IDC_BUTTON_ICON_TEST, this));
	//buttonUP.SizeToContent();




	//GetDlgItem(IDC_BUTTON_ICON_TEST)->SendMessage(BM_SETIMAGE, IMAGE_ICON, IDI_ICON_UP);
	//temp ICON
	//hIcon = LoadIcon(
	//GetDlgItem(IDC_BUTTON_ICON_TEST)->SetIcon(
//	GetDlgItem(IDC_BUTTON_ICON_TEST)->SetIcon( ::LoadIcon(NULL,MAKEINTRESOURCE(IDI_ICON_UP)), FALSE);
	//GetDlgItem(IDC_BUTTON_ICON_TEST)->(  LoadIcon(NULL, IDI_ICON_UP);// EnableWindow(FALSE);
	//SendDlgItemMessage(IDC_BUTTON_ICON_TEST,BM_SETIMAGE, IMAGE_ICON, IDI_ICON_UP);

	//x hI = LoadIcon(NULL,MAKEINTRESOURCE(IDI_ICON_UP));
//	hI = GetDlgItem(IDC_BUTTON_ICON_TEST)->GetIcon(FALSE);
	

	if (!(filmAble = tc1.FilmAble()))
		GetDlgItem(IDC_BUTTON_DO_FILM)->EnableWindow(FALSE); 
	else GetDlgItem(IDC_BUTTON_DO_FILM)->EnableWindow(TRUE); 

	//Operating mode status (0Dh)=====================================
	temp = tc1.ModeStatus();
//	if (tc1.BrdType() == 4)	//PCI
//		temp = tc1.Read1(0x000D);	//pci
//	else 
//		temp = tc1.Read1(0x03E8);   //isa
	
	CheckDlgButton(IDC_CHECK_DIAGMODE, ((temp & 0x80) ? 1 : 0));
	//CheckDlgButton(nID, ((temp & 0x40) ? 1 : 0));	//see a few lines below
	CheckDlgButton(IDC_CHECK_LTCSELECTMODE, ((temp & 0x20) ? 1 : 0));
	CheckDlgButton(IDC_CHECK_VITCSELECTMODE, ((temp & 0x20) ? 0 : 1));

	//IDC_CHECK_FILMMODE
	if (filmAble)
	{
		if (temp & 0x40) //we are in FILM/HD (24fps) mode
		{
			CheckDlgButton(IDC_CHECK_FILMMODE, 1);
			CheckDlgButton(IDC_CHECK_EBUMODE, 0);
			CheckDlgButton(IDC_CHECK_SMPTEMODE, 0);
		}
		else
		{
			CheckDlgButton(IDC_CHECK_FILMMODE, 0);
			CheckDlgButton(IDC_CHECK_EBUMODE, ((temp & 0x10) ? 1 : 0));
			CheckDlgButton(IDC_CHECK_SMPTEMODE, ((temp & 0x10) ? 0 : 1));
		}
	}

	CheckDlgButton(IDC_CHECK_VGENMODE, ((temp & 0x08)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_LGENMODE, ((temp & 0x04)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_VL21RDRMODE, ((temp & 0x02)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_LRDRMODE, ((temp & 0x01)  ? 1 : 0 ));

	cmp0D = temp;

	if (tc1.GensVitc())
		CheckDlgButton(IDC_CHECK_GEN_VITC, ((temp & 0x08)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_GEN_VITC)->EnableWindow(FALSE);
	if (tc1.GensLtc())
		CheckDlgButton(IDC_CHECK_GEN_LTC, ((temp & 0x04)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_GEN_LTC)->EnableWindow(FALSE);
	if (tc1.ReadsVitc())
		CheckDlgButton(IDC_CHECK_READ_VITC, ((temp & 0x02)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_READ_VITC)->EnableWindow(FALSE);
	if (tc1.ReadsLtc())
		CheckDlgButton(IDC_CHECK_READ_LTC, ((temp & 0x01)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_READ_LTC)->EnableWindow(FALSE);

	
	//signal status (0Ch)==========================================
	if (tc1.BrdType() == 4)	//PCI
		temp = (tc1.Read1(0x000C) & 0x7F);   //pci, mask bit7
			//		 bits  => 6=L21 input data OK,
							//5=VITC input data OK
							//4=LTC input data OK
							//3=Wide sync pluses detected
							//2=
							//1=odd video field
							//0=video input OK
	else 
		temp = (tc1.Read1(0x0049) & 0x1F);   //isa, mask bits 7/6/5

							//4=LTC input data OK
							//3=Wide sync pluses detected
							//2=
							//1=odd video field
							//0=video input OK

	//CheckDlgButton(nID, ((temp & 0x80)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_L21STAT, ((temp & 0x40)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_VITCSTAT, ((temp & 0x20)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_LTCSTAT, ((temp & 0x10)  ? 1 : 0 ));

	CheckDlgButton(IDC_CHECK_VSYNCSTAT, ((temp & 0x08)  ? 1 : 0 ));
	//CheckDlgButton(nID, ((temp & 0x04)  ? 1 : 0 ));
//	if ((temp & 0x01))	//check the video OK first
//		CheckDlgButton(IDC_CHECK_FIELDSTAT, ((temp & 0x02)  ? 1 : 0 ));
//	else CheckDlgButton(IDC_CHECK_FIELDSTAT, 0);	//turn OFF
	CheckDlgButton(IDC_CHECK_VIDSTAT, ((temp & 0x01)  ? 1 : 0 ));
	cmp0C = temp;


	//Interupt Enables (2E/3F0)==========================================
	if (tc1.BrdType() == 4)	//PCI
		temp = (tc1.Read1(0x002E) & 0x7F);   //pci, mask bit7
	else 
		temp = (tc1.Read1(0x03F0) & 0x7F);   //isa, mask bit7
			//		 bits  => 6= L21 Data Reader
							//5= TC comparator
							//4= Serial RX
							//3= Serial TX
							//2= TC Gen
							//1= video Field 
							//0= TC Reader 
	//CheckDlgButton(nID, ((temp & 0x80) ? 1 : 0));
	CheckDlgButton(AEC_CHECK_INT_L21ON, ((temp & 0x40) ? 1 : 0));
	CheckDlgButton(AEC_CHECK_INT_CMPON, ((temp & 0x20) ? 1 : 0));
	CheckDlgButton(AEC_CHECK_INT_RXON, ((temp & 0x10) ? 1 : 0));

	CheckDlgButton(AEC_CHECK_INT_TXON, ((temp & 0x08)  ? 1 : 0 ));
	CheckDlgButton(AEC_CHECK_INT_GENON, ((temp & 0x04)  ? 1 : 0 ));
	CheckDlgButton(AEC_CHECK_INT_VIDON, ((temp & 0x02)  ? 1 : 0 ));
	CheckDlgButton(AEC_CHECK_INT_RDRON, ((temp & 0x01)  ? 1 : 0 ));
	cmp2E = temp;


	//GetDlgItem(IDC_CHECK_SIO_GENERIC_DLG)->EnableWindow(FALSE);
	//GetDlgItem(IDC_CHECK_SONY422_DLG)->EnableWindow(FALSE);
	//GetDlgItem(IDC_CHECK_L21_DLGBOX)->EnableWindow(FALSE);
	//GetDlgItem(IDC_CHECK_ISR_ONLY)->EnableWindow(FALSE);

}

//=======================================================================
void CAecMfc32TimeCodeDlg::InitGenStatus()
{
	BYTE temp;
	int frz, able;
	if (tc1.GensLtc() || tc1.GensVitc())
	{

		//Gen output operating mode status (4A/45h)========================
		if (tc1.BrdType() == 4)	//PCI
		{
			temp = tc1.Read1(0x004A);	//pci
			if (temp & 0x01)
				frz = 1;
			else frz = 0;
			if (temp & 0x02)
				able = 1;
			else able = 0;
		}
		else 
		{
			temp = tc1.Read1(0x0045);   //isa
			if (temp & 0x40)
				frz = 0;		//UNFrozen = 0
			else frz = 1;
			if (temp & 0x80)
				able = 0;		//DISabled =0
			else able = 1;
		}
		if (frz && able)	//gen is active normal
		{
			SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "STOP");
			CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 1);
			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Time");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
			return;
		}

			
		SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "RUN");
		CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 0);

		if (frz)	//NOT frozen 
		{

			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Time");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
			//SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Enable Output");
			//CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 1);
		}
		else
		{
			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Unfreeze Time");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
		}

		if (able)	//ENABLED
		{
			//SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Time");
			//CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
		}
		else
		{
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Enable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 1);
		}
	}
//	else //no gen
//	{
//
//	}

}

//=======================================================================
void CAecMfc32TimeCodeDlg::InitGenStatusAll()
{
	BYTE temp;
	int frz, able;
	BYTE b = tc1.GetGenModeControl();
	if (tc1.GensLtc() || tc1.GensVitc())
	{
		if (b & BIT0)
			CheckRadioButton(IDC_RADIO_CMPREAD, IDC_RADIO_CMPGEN, IDC_RADIO_CMPREAD);
		else
			CheckRadioButton(IDC_RADIO_CMPREAD, IDC_RADIO_CMPGEN, IDC_RADIO_CMPGEN);

		//Gen output operating mode status (4A/45h)========================
		if (tc1.BrdType() == 4)	//PCI
		{
			temp = tc1.Read1(0x004A);	//pci
			if (temp & 0x01)
				frz = 1;
			else frz = 0;
			if (temp & 0x02)
				able = 1;
			else able = 0;
		}
		else 
		{
			temp = tc1.Read1(0x0045);   //isa
			if (temp & 0x40)
				frz = 0;		//UNFrozen = 0
			else frz = 1;
			if (temp & 0x80)
				able = 0;		//DISabled =0
			else able = 1;
		}
		if (frz && able)	//gen is active normal
		{
			SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "STOP");
			CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 1);
			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Time");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
			return;
		}

			
		SetDlgItemText(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, "RUN");
		CheckDlgButton(IDC_CHECK_GEN_RUNUNCHANGEDSTOP, 0);

		if (frz)	//NOT frozen 
		{

			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Time");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
			//SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Enable Output");
			//CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 1);
		}
		else
		{
			SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Unfreeze Time");
			CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 1);
		}

		if (able)	//ENABLED
		{
			//SetDlgItemText(IDC_CHECK_GEN_PAUSE_GO, "Freeze Time");
			//CheckDlgButton(IDC_CHECK_GEN_PAUSE_GO, 0);
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Disable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 0);
		}
		else
		{
			SetDlgItemText(IDC_CHECK_GEN_DIS_ENABLE, "Enable Output");
			CheckDlgButton(IDC_CHECK_GEN_DIS_ENABLE, 1);
		}
	}
	else //no gen
	{
		tc1.SetGenModeControl(b | BIT1);	//set bit1
		CheckRadioButton(IDC_RADIO_CMPREAD, IDC_RADIO_CMPGEN, IDC_RADIO_CMPREAD);
		GetDlgItem(IDC_RADIO_CMPGEN)->EnableWindow(FALSE); //diable comp to gen

		GetDlgItem(IDC_BUTTON_FORCE_GEN_UPDATE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_BUTTON_JAMGENALL)->EnableWindow(FALSE); 
		GetDlgItem(IDC_BUTTON_JAMGENTB)->EnableWindow(FALSE); 
		GetDlgItem(IDC_BUTTON_JAMGENUB)->EnableWindow(FALSE); 
		GetDlgItem(IDC_BUTTON_JAMGENEB)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_GEN_RUNUNCHANGEDSTOP)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_GEN_PAUSE_GO)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_GEN_DIS_ENABLE)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_GENDF)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_GENDOWN)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_GENCF)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_JAM_READER)->EnableWindow(FALSE); 
		GetDlgItem(IDC_CHECK_NOJAMUB)->EnableWindow(FALSE); 
		GetDlgItem(IDC_RADIO_SYNC_VID)->EnableWindow(FALSE); 
		GetDlgItem(IDC_RADIO_SYNC_LTC)->EnableWindow(FALSE); 
		GetDlgItem(IDC_RADIO_GEN_FREERUN)->EnableWindow(FALSE); 
		//
		SetDlgItemText(IDC_EDIT_TBGEN_OUTPUT, " n/a ");
		SetDlgItemText(IDC_EDIT_UBGEN_OUTPUT, " n/a ");
		SetDlgItemText(IDC_EDIT_DFGEN_OUTPUT, " n/a ");
		SetDlgItemText(IDC_EDIT_CFGEN_OUTPUT, " n/a ");

	}
}
//=======================================================================
//=======================================================================
//GetDlgItem(IDC_RADIO_DF)->EnableWindow(FALSE); 
//			if (aec.m_bDF)
//				CheckRadioButton(IDC_RADIO_DF, IDC_RADIO_NDF, IDC_RADIO_DF);
//			else CheckRadioButton(IDC_RADIO_DF, IDC_RADIO_NDF, IDC_RADIO_NDF);


/*
IDC_BUTTON_ICON_TEST

  SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
  SendDlgItemMessage(hwndDlg, IDC_X_ROW1_B0, BM_SETCHECK, 1, 0); //play

Icon
Specifies that the button displays an icon (BS_ICON) instead of text.
Type: Bool. Default: False. 
The BS_ICON is a new button style in Windows 95.  
After a button is created with this style, assign the icon to the 
button by sending a BM_SETIMAGE message to the button with the wParam 
as IMAGE_ICON and lParam as a handle to the icon.  Windows displays 
the specified icon on the button.
The system handles cleanup of icons or cursors loaded from resources. 
Therefore, the icon should not be deleted unless the icon was created 
at run time by using CreateIcon function.
  */

//=======================================================================
//Handle a message from the Sony RS422 dialog box
void CAecMfc32TimeCodeDlg::OnWmAecSony422(WPARAM wP, LPARAM lP)
{

	DWBYTES hmsf;
	tc1.InitRx();
	switch (wP)
	{	
		
		case PLAY:
			tc1.Play();
			break;
		case STOP:
			tc1.Stop();
			break;
		case REW:
			tc1.Rewind();
			break;
		case FWD:
			tc1.FastForward();
			break;
		case PAUSE:
			tc1.Pause();
			break;
		case RECORD:
			tc1.Record();
			break;
		case GOTO:
			hmsf.d = (DWORD) lP;
			tc1.Cue(hmsf.b.h, hmsf.b.m, hmsf.b.s, hmsf.b.f);
			break;
		case CLOSE:
			if (pDlgSony422 != NULL)
			{
				pDlgSony422->EndDialog(TRUE);
				delete pDlgSony422;
			}
			pDlgSony422 = NULL;
			CheckDlgButton(IDC_CHECK_SONY422_DLG, 0);
			GetDlgItem(IDC_CHECK_SIO_GENERIC_DLG)->EnableWindow(TRUE);
			break;
		case SHTL_FWD:
			tc1.ShtlF(speed);
			break;
		case SHTL_REV:
			tc1.ShtlR(speed);
			break;
		case JOG_FWD:
			//tc1.???
			break;
		case JOG_REV:
			//tc1.???
			break;
		case TCVITC:	//select VITC reader
			tc1.UseTC();
			break;
		case TCLTC:		//select LTC reader
			tc1.UseTC();
			break;
		case TCCTL:		//select Control Track time
			tc1.UseCtl();
			break;
		case STATUS:	//do a status sense cmd
			tc1.Status();
			break;
		case TCSENSE_CTL:	//do a time code sense cmd
			tc1.Tmr1();
			break;
		case TCSENSE_LTC:	//do a time code sense cmd
			tc1.LTCc();
			break;
		case TCSENSE_VITC:	//do a time code sense cmd
			tc1.VITCc();
			break;
		default:
			MessageBox("not defined", "RS422 SIO", MB_OK);

	}

}

/*
BOOL CAec::Play()			//play
BOOL CAec::Stop()			//stop
BOOL CAec::Pause()			//pause
BOOL CAec::Record()		//record
BOOL CAec::FastForward()	//fast_forward
BOOL CAec::Rewind()		//rewind_tape
BOOL CAec::Eject()			//eject
BOOL CAec::Tmr1_reset()	//timer1 reset
BOOL CAec::Tmr1()			//ctl/timer1 time sense
BOOL CAec::LTCc()			//ltc time sense
BOOL CAec::VITCc()			//vitc time sense
BOOL CAec::Status()		//vtr status sense
BOOL CAec::Status(BYTE stat)	//vtr status sense
BOOL CAec::Cue(BYTE hh, BYTE mm, BYTE ss, BYTE ff)	//cue/goto HH:MM:SS:FF
BOOL CAec::ShtlF(BYTE speed)	//shuttle forward at 'speed'
BOOL CAec::ShtlR(BYTE speed)	//shuttle reverse at 'speed'
BOOL CAec::UseTC()			//set to use Timecode (not CTL) mode
BOOL CAec::UseCtl()		//set to use Timer1/CTL (not timecode) mode
BOOL CAec::TMS()			//request time mode sense (currently in use)
*/


//=======================================================================
//Handle a message from the Generic SIO dialog box
void CAecMfc32TimeCodeDlg::OnWmAecSIO(WPARAM wP, LPARAM lP)
{
	DWBYTES db;
	BYTE cmd;
	switch (wP)
	{
		case WRITE_0:
			if (tc1.BrdType() == 4)
				tc1.Write4((DWORD)lP, 0x0070);
			else 
			{
				db.d = (DWORD) lP;
				m_sioBuff16[0] = db.b.f;	//FOR ISA, needs more work!!!!! 
				m_sioBuff16[1] = db.b.s;	//0x0110 str1, 0x0120 str2, 0x130 str3...
				m_sioBuff16[2] = db.b.m;
				m_sioBuff16[3] = db.b.h;
			}
			break;

		case WRITE_1:
			if (tc1.BrdType() == 4)
				tc1.Write4((DWORD)lP, 0x0074);
			else 
			{
				db.d = (DWORD) lP;
				m_sioBuff16[4] = db.b.f;	//FOR ISA, needs more work!!!!! 
				m_sioBuff16[5] = db.b.s;	//0x0110 str1, 0x0120 str2, 0x130 str3...
				m_sioBuff16[6] = db.b.m;
				m_sioBuff16[7] = db.b.h;
			}
			break;

		case WRITE_2:
			if (tc1.BrdType() == 4)
				tc1.Write4((DWORD)lP, 0x0078);
			else 
			{
				db.d = (DWORD) lP;
				m_sioBuff16[8] = db.b.f;	//FOR ISA, needs more work!!!!! 
				m_sioBuff16[9] = db.b.s;	//0x0110 str1, 0x0120 str2, 0x130 str3...
				m_sioBuff16[10] = db.b.m;
				m_sioBuff16[11] = db.b.h;
			}
			break;

		case WRITE_3:
			if (tc1.BrdType() == 4)
				tc1.Write4((DWORD)lP, 0x007C);
			else 
			{
				db.d = (DWORD) lP;
				m_sioBuff16[12] = db.b.f;	//FOR ISA, needs more work!!!!! 
				m_sioBuff16[13] = db.b.s;	//0x0110 str1, 0x0120 str2, 0x130 str3...
				m_sioBuff16[14] = db.b.m;
				m_sioBuff16[15] = db.b.h;
			}
			break;
		case BAUD:			//3C
			if (tc1.BrdType() == 4)
				tc1.Write1((BYTE) lP, 0x003C);
			else	//ISA
			{
				//TODO:
			}
			break;
		case BITSPARITY:	//3D
			if (tc1.BrdType() == 4)
				tc1.Write1((BYTE) lP, 0x003D);
			else	//ISA
			{
				//TODO:
			}
			break;
		case TIMEOUT:		//3E
			if (tc1.BrdType() == 4)
				tc1.Write1((BYTE) lP, 0x003E);
			else	//ISA
			{
				//TODO:
			}
			break;

		case CMD:	//LPARAM LOW BYTE WILL HOLD COMMAND
			cmd = (BYTE)lP;
			if (tc1.BrdType() == 4)
				tc1.SendCom(cmd);
			else	//ISA
			{
				if ((cmd & 0xF0) == 0x90)
				{
					//TODO: stuff 'm_sioBuff16' to appropriate DPRAM location of ISA board...
				}
			}
			break;

		case CLOSE:
			if (pDlgSIO != NULL)
			{
				pDlgSIO->EndDialog(TRUE);
				delete pDlgSIO;
			}
			pDlgSIO = NULL;
			CheckDlgButton(IDC_CHECK_SIO_GENERIC_DLG, 0);	//IDC_CHECK_SIO_GENERIC_DLG
			GetDlgItem(IDC_CHECK_SONY422_DLG)->EnableWindow(TRUE);
			break;

		default:
			MessageBox("not defined", "SIO", MB_OK);

	}
}

//=======================================================================
//Handle a message from the L21 dialog box
void CAecMfc32TimeCodeDlg::OnWmAecL21(WPARAM wP, LPARAM lP)
{

	//DWBYTES hmsf;
	switch (wP)
	{

		case CLOSE:
			if (pDlgL21 != NULL)
			{
				pDlgL21->EndDialog(TRUE);
				delete pDlgL21;
				tc1.ResetL21Buffer();
			}
			pDlgL21 = NULL;
			CheckDlgButton(IDC_CHECK_L21_DLGBOX, 0);	
			break;

		default:
			MessageBox("not defined", "L21 Reader", MB_OK);

	}
}

//=======================================================================

void CAecMfc32TimeCodeDlg::OnWmOSD(WPARAM wp, LPARAM lp)
{
	switch (wp)
	{
		case CLOSE:
			if (pDlgOSD != NULL)
			{
				pDlgOSD->EndDialog(TRUE);
				delete pDlgOSD;
			}
			pDlgOSD = NULL;
			CheckDlgButton(IDC_CHECK_OSD_DLGBOX, 0);	
			break;

		default:
			MessageBox("not defined", "OSD", MB_OK);

	}
}

//=======================================================================
//take the string of WORD data and print to the edit box
//(IDC_EDIT_RX_OUT, tc1.GetRxWStr(w, 10), w)
void CAecMfc32TimeCodeDlg::WriteHexStringToEditBox(int nID, int len, LPWORD w)
{

	int i, j;
	char chs[5];
	char str[32];
	str[0] = 0;
	j = len;
	if (j > 8)
		j = 8;
	for (i = 0; i<j; i++)
	{
		wsprintf (chs,"%4.4X",w[i]);
		chs[4] = 0;
		strcat(str, chs);
	}

	SetDlgItemText(nID, str);
	
}

//=======================================================================
//take the string of WORD data and print to the edit box
//(IDC_EDIT_RX_OUT, tc1.GetRxWStr(w, 10), w)
void CAecMfc32TimeCodeDlg::WriteHexStringToEditBox(int nID, int len, LPDWORD dw)
{

	int i, j;
	char chs[9];
	char str[65];
	str[0] = 0;
	j = len;
	if (j > 8)
		j = 8;
	for (i = 0; i<j; i++)
	{
		wsprintf (chs,"%8.8X",dw[i]);
		//chs[8] = 0;
		strcat(str, chs);
	}
	SetDlgItemText(nID, str);	
}
//=======================================================================

void CAecMfc32TimeCodeDlg::OnDestroy() 
{
	if (pDlgOSD)
		delete pDlgOSD;
	if (pDlgSony422)
		delete pDlgSony422;
	if (pDlgSIO)
		delete pDlgSIO;
	if (pDlgL21)
		delete pDlgL21;

	// TODO: Add shut down and cleanup code here. The program is exiting.
	// makes sure to clear any hardware interrupts if the IRQs are enabled.
	if (m_Dlg_Timer)
	{
		//MessageBeep(-1);
		KillTimer(m_Dlg_Timer);
		m_Dlg_Timer = 0;
	}
	//do the rest of the cleanup of the PC-TC device(s)
	tc1.exiting = TRUE;
		// TODO: Force an interrupt to make sure ISR loop ends.
		// --> For 'Smart' boards, just send a command to 3FF
		//		this will cause an interrupt
		//Purpose: This will allow the ISR thread to exit cleanly
		//			without leaving residual effects 
		tc1.SendCom(0x5B);	// will generate an int (PCI ok, NAK reply for ISA)
							//Choose any Command wanted ie: 0x5B = MDOP status
	tc1.DoISR(false);

	CDialog::OnDestroy();
		
}

void CAecMfc32TimeCodeDlg::OnCheckPollFast() 
{
	KillTimer(m_Dlg_Timer);
	if (IsDlgButtonChecked(IDC_CHECK_POLL_FAST))
	{
		m_PollFast = false;
		m_Dlg_Timer = SetTimer(1, 500, 0);
	}
	else 
	{
		m_PollFast = true;	
		m_Dlg_Timer = SetTimer(1, 10, 0);
	}
}
